
_interrupt:

;ThrottleMonitor2.mbas,185 :: 		sub procedure interrupt
;ThrottleMonitor2.mbas,188 :: 		if SPEED_SIGNAL_INTERRUPT_OCCURRED = 1 then
	BTFSS      IOCBF2_bit+0, BitPos(IOCBF2_bit+0)
	GOTO       L__interrupt2
;ThrottleMonitor2.mbas,189 :: 		if speed_measure_status = MEASUREMENT_RUNNING then
	MOVF       _speed_measure_status+0, 0
	XORLW      1
	BTFSS      STATUS+0, 2
	GOTO       L__interrupt5
;ThrottleMonitor2.mbas,190 :: 		speed_pulse_counter = speed_pulse_counter + 1
	INCF       _speed_pulse_counter+0, 1
;ThrottleMonitor2.mbas,191 :: 		if speed_pulse_counter = SPEED_PULSE_COUNT then
	MOVF       _speed_pulse_counter+0, 0
	XORLW      5
	BTFSS      STATUS+0, 2
	GOTO       L__interrupt8
;ThrottleMonitor2.mbas,192 :: 		speed_tmr_save = TMR4
	MOVF       TMR4+0, 0
	MOVWF      _speed_tmr_save+0
;ThrottleMonitor2.mbas,193 :: 		speed_tmr_overflow_save  = speed_tmr_overflow_count
	MOVF       _speed_tmr_overflow_count+0, 0
	MOVWF      _speed_tmr_overflow_save+0
	MOVF       _speed_tmr_overflow_count+1, 0
	MOVWF      _speed_tmr_overflow_save+1
	CLRF       _speed_tmr_overflow_save+2
	CLRF       _speed_tmr_overflow_save+3
;ThrottleMonitor2.mbas,194 :: 		speed_measure_status  = MEASUREMENT_DONE
	MOVLW      2
	MOVWF      _speed_measure_status+0
L__interrupt8:
;ThrottleMonitor2.mbas,195 :: 		end if
L__interrupt5:
;ThrottleMonitor2.mbas,197 :: 		if speed_measure_status = MEASUREMENT_SET then
	MOVF       _speed_measure_status+0, 0
	XORLW      0
	BTFSS      STATUS+0, 2
	GOTO       L__interrupt11
;ThrottleMonitor2.mbas,198 :: 		TMR4 = 0
	CLRF       TMR4+0
;ThrottleMonitor2.mbas,199 :: 		speed_tmr_overflow_count = 0
	CLRF       _speed_tmr_overflow_count+0
	CLRF       _speed_tmr_overflow_count+1
;ThrottleMonitor2.mbas,200 :: 		speed_tmr_timeout = false
	CLRF       _speed_tmr_timeout+0
;ThrottleMonitor2.mbas,201 :: 		speed_pulse_counter = 0
	CLRF       _speed_pulse_counter+0
;ThrottleMonitor2.mbas,202 :: 		speed_measure_status = MEASUREMENT_RUNNING
	MOVLW      1
	MOVWF      _speed_measure_status+0
L__interrupt11:
;ThrottleMonitor2.mbas,204 :: 		SPEED_SIGNAL_INTERRUPT_OCCURRED = 0
	BCF        IOCBF2_bit+0, BitPos(IOCBF2_bit+0)
L__interrupt2:
;ThrottleMonitor2.mbas,208 :: 		if TACHO_SIGNAL_INTERRUPT_OCCURRED = 1 then
	BTFSS      INTF_bit+0, BitPos(INTF_bit+0)
	GOTO       L__interrupt14
;ThrottleMonitor2.mbas,209 :: 		if tacho_measure_status = MEASUREMENT_RUNNING then
	MOVF       _tacho_measure_status+0, 0
	XORLW      1
	BTFSS      STATUS+0, 2
	GOTO       L__interrupt17
;ThrottleMonitor2.mbas,210 :: 		tacho_pulse_counter = tacho_pulse_counter + 1
	INCF       _tacho_pulse_counter+0, 1
;ThrottleMonitor2.mbas,211 :: 		if tacho_pulse_counter = TACHO_PULSE_COUNT then
	MOVF       _tacho_pulse_counter+0, 0
	XORLW      1
	BTFSS      STATUS+0, 2
	GOTO       L__interrupt20
;ThrottleMonitor2.mbas,212 :: 		tacho_tmr_save = TMR6
	MOVF       TMR6+0, 0
	MOVWF      _tacho_tmr_save+0
;ThrottleMonitor2.mbas,213 :: 		tacho_tmr_overflow_save  = tacho_tmr_overflow_count
	MOVF       _tacho_tmr_overflow_count+0, 0
	MOVWF      _tacho_tmr_overflow_save+0
	MOVF       _tacho_tmr_overflow_count+1, 0
	MOVWF      _tacho_tmr_overflow_save+1
	CLRF       _tacho_tmr_overflow_save+2
	CLRF       _tacho_tmr_overflow_save+3
;ThrottleMonitor2.mbas,214 :: 		tacho_measure_status  = MEASUREMENT_DONE
	MOVLW      2
	MOVWF      _tacho_measure_status+0
L__interrupt20:
;ThrottleMonitor2.mbas,215 :: 		end if
L__interrupt17:
;ThrottleMonitor2.mbas,217 :: 		if tacho_measure_status = MEASUREMENT_SET then
	MOVF       _tacho_measure_status+0, 0
	XORLW      0
	BTFSS      STATUS+0, 2
	GOTO       L__interrupt23
;ThrottleMonitor2.mbas,218 :: 		TMR6 = 0
	CLRF       TMR6+0
;ThrottleMonitor2.mbas,219 :: 		tacho_tmr_overflow_count = 0
	CLRF       _tacho_tmr_overflow_count+0
	CLRF       _tacho_tmr_overflow_count+1
;ThrottleMonitor2.mbas,220 :: 		tacho_tmr_timeout = false
	CLRF       _tacho_tmr_timeout+0
;ThrottleMonitor2.mbas,221 :: 		tacho_pulse_counter = 0
	CLRF       _tacho_pulse_counter+0
;ThrottleMonitor2.mbas,222 :: 		tacho_measure_status = MEASUREMENT_RUNNING
	MOVLW      1
	MOVWF      _tacho_measure_status+0
L__interrupt23:
;ThrottleMonitor2.mbas,224 :: 		TACHO_SIGNAL_INTERRUPT_OCCURRED = 0
	BCF        INTF_bit+0, BitPos(INTF_bit+0)
L__interrupt14:
;ThrottleMonitor2.mbas,228 :: 		if TMR2IF_bit = 1 then
	BTFSS      TMR2IF_bit+0, BitPos(TMR2IF_bit+0)
	GOTO       L__interrupt26
;ThrottleMonitor2.mbas,230 :: 		if speed_display_update_counter < 300 then  ' 300[mec]
	MOVLW      1
	SUBWF      _speed_display_update_counter+1, 0
	BTFSS      STATUS+0, 2
	GOTO       L__interrupt412
	MOVLW      44
	SUBWF      _speed_display_update_counter+0, 0
L__interrupt412:
	BTFSC      STATUS+0, 0
	GOTO       L__interrupt29
;ThrottleMonitor2.mbas,231 :: 		speed_display_update_counter = speed_display_update_counter + 1
	INCF       _speed_display_update_counter+0, 1
	BTFSC      STATUS+0, 2
	INCF       _speed_display_update_counter+1, 1
L__interrupt29:
;ThrottleMonitor2.mbas,234 :: 		if dimmer_update_counter < 100 then         ' 100[mec]
	MOVLW      100
	SUBWF      _dimmer_update_counter+0, 0
	BTFSC      STATUS+0, 0
	GOTO       L__interrupt32
;ThrottleMonitor2.mbas,235 :: 		dimmer_update_counter = dimmer_update_counter + 1
	INCF       _dimmer_update_counter+0, 1
L__interrupt32:
;ThrottleMonitor2.mbas,237 :: 		TMR2IF_bit = 0
	BCF        TMR2IF_bit+0, BitPos(TMR2IF_bit+0)
L__interrupt26:
;ThrottleMonitor2.mbas,241 :: 		if TMR4IF_bit = 1 then
	BTFSS      TMR4IF_bit+0, BitPos(TMR4IF_bit+0)
	GOTO       L__interrupt35
;ThrottleMonitor2.mbas,242 :: 		if speed_tmr_overflow_count = 31250 then  ' 31250 = 1sec
	MOVF       _speed_tmr_overflow_count+1, 0
	XORLW      122
	BTFSS      STATUS+0, 2
	GOTO       L__interrupt413
	MOVLW      18
	XORWF      _speed_tmr_overflow_count+0, 0
L__interrupt413:
	BTFSS      STATUS+0, 2
	GOTO       L__interrupt38
;ThrottleMonitor2.mbas,243 :: 		speed_tmr_timeout = true
	MOVLW      255
	MOVWF      _speed_tmr_timeout+0
	GOTO       L__interrupt39
;ThrottleMonitor2.mbas,244 :: 		else
L__interrupt38:
;ThrottleMonitor2.mbas,245 :: 		speed_tmr_overflow_count = speed_tmr_overflow_count + 1
	INCF       _speed_tmr_overflow_count+0, 1
	BTFSC      STATUS+0, 2
	INCF       _speed_tmr_overflow_count+1, 1
;ThrottleMonitor2.mbas,246 :: 		end if
L__interrupt39:
;ThrottleMonitor2.mbas,247 :: 		TMR4IF_bit = 0
	BCF        TMR4IF_bit+0, BitPos(TMR4IF_bit+0)
L__interrupt35:
;ThrottleMonitor2.mbas,251 :: 		if TMR6IF_bit = 1 then
	BTFSS      TMR6IF_bit+0, BitPos(TMR6IF_bit+0)
	GOTO       L__interrupt41
;ThrottleMonitor2.mbas,252 :: 		if tacho_tmr_overflow_count = 31250 then  ' 31250 = 1sec
	MOVF       _tacho_tmr_overflow_count+1, 0
	XORLW      122
	BTFSS      STATUS+0, 2
	GOTO       L__interrupt414
	MOVLW      18
	XORWF      _tacho_tmr_overflow_count+0, 0
L__interrupt414:
	BTFSS      STATUS+0, 2
	GOTO       L__interrupt44
;ThrottleMonitor2.mbas,253 :: 		tacho_tmr_timeout = true
	MOVLW      255
	MOVWF      _tacho_tmr_timeout+0
	GOTO       L__interrupt45
;ThrottleMonitor2.mbas,254 :: 		else
L__interrupt44:
;ThrottleMonitor2.mbas,255 :: 		tacho_tmr_overflow_count = tacho_tmr_overflow_count + 1
	INCF       _tacho_tmr_overflow_count+0, 1
	BTFSC      STATUS+0, 2
	INCF       _tacho_tmr_overflow_count+1, 1
;ThrottleMonitor2.mbas,256 :: 		end if
L__interrupt45:
;ThrottleMonitor2.mbas,257 :: 		TMR6IF_bit = 0
	BCF        TMR6IF_bit+0, BitPos(TMR6IF_bit+0)
L__interrupt41:
;ThrottleMonitor2.mbas,260 :: 		end sub
L_end_interrupt:
L__interrupt411:
	RETFIE     %s
; end of _interrupt

_write_tca9535:

;ThrottleMonitor2.mbas,265 :: 		sub procedure write_tca9535(dim device_address as byte, dim command_byte as byte, dim w_data as byte )
;ThrottleMonitor2.mbas,266 :: 		I2C1_Start()
	CALL       _I2C1_start+0
;ThrottleMonitor2.mbas,267 :: 		I2C1_Wr(TCA9535_DEVICE_ADDRESS or device_address or TCA9535_WRITE)
	MOVLW      64
	IORWF       FARG_write_tca9535_device_address+0, 0
	MOVWF      FARG_I2C1_Wr_data_+0
	CALL       _I2C1_Wr+0
;ThrottleMonitor2.mbas,268 :: 		I2C1_Wr(command_byte)
	MOVF       FARG_write_tca9535_command_byte+0, 0
	MOVWF      FARG_I2C1_Wr_data_+0
	CALL       _I2C1_Wr+0
;ThrottleMonitor2.mbas,269 :: 		I2C1_Wr(w_data)
	MOVF       FARG_write_tca9535_w_data+0, 0
	MOVWF      FARG_I2C1_Wr_data_+0
	CALL       _I2C1_Wr+0
;ThrottleMonitor2.mbas,270 :: 		I2C1_Stop()
	CALL       _I2C1_Stop+0
;ThrottleMonitor2.mbas,271 :: 		end sub
L_end_write_tca9535:
	RETURN
; end of _write_tca9535

_display_char:

;ThrottleMonitor2.mbas,276 :: 		sub procedure display_char(dim digit as byte, dim char_mask as byte )
;ThrottleMonitor2.mbas,278 :: 		case 1  write_tca9535( IOEXPANDER_DEVICE_ID2, TCA9535_OUTPUT_PORT0, char_mask )
	MOVF       FARG_display_char_digit+0, 0
	XORLW      1
	BTFSS      STATUS+0, 2
	GOTO       L__display_char51
	MOVLW      4
	MOVWF      FARG_write_tca9535_device_address+0
	MOVLW      2
	MOVWF      FARG_write_tca9535_command_byte+0
	MOVF       FARG_display_char_char_mask+0, 0
	MOVWF      FARG_write_tca9535_w_data+0
	CALL       _write_tca9535+0
	GOTO       L__display_char48
L__display_char51:
;ThrottleMonitor2.mbas,279 :: 		case 2  write_tca9535( IOEXPANDER_DEVICE_ID2, TCA9535_OUTPUT_PORT1, char_mask )
	MOVF       FARG_display_char_digit+0, 0
	XORLW      2
	BTFSS      STATUS+0, 2
	GOTO       L__display_char54
	MOVLW      4
	MOVWF      FARG_write_tca9535_device_address+0
	MOVLW      3
	MOVWF      FARG_write_tca9535_command_byte+0
	MOVF       FARG_display_char_char_mask+0, 0
	MOVWF      FARG_write_tca9535_w_data+0
	CALL       _write_tca9535+0
	GOTO       L__display_char48
L__display_char54:
;ThrottleMonitor2.mbas,280 :: 		case 3  write_tca9535( IOEXPANDER_DEVICE_ID3, TCA9535_OUTPUT_PORT0, char_mask )
	MOVF       FARG_display_char_digit+0, 0
	XORLW      3
	BTFSS      STATUS+0, 2
	GOTO       L__display_char57
	MOVLW      6
	MOVWF      FARG_write_tca9535_device_address+0
	MOVLW      2
	MOVWF      FARG_write_tca9535_command_byte+0
	MOVF       FARG_display_char_char_mask+0, 0
	MOVWF      FARG_write_tca9535_w_data+0
	CALL       _write_tca9535+0
	GOTO       L__display_char48
L__display_char57:
;ThrottleMonitor2.mbas,281 :: 		case 4  write_tca9535( IOEXPANDER_DEVICE_ID3, TCA9535_OUTPUT_PORT1, char_mask )
	MOVF       FARG_display_char_digit+0, 0
	XORLW      4
	BTFSS      STATUS+0, 2
	GOTO       L__display_char60
	MOVLW      6
	MOVWF      FARG_write_tca9535_device_address+0
	MOVLW      3
	MOVWF      FARG_write_tca9535_command_byte+0
	MOVF       FARG_display_char_char_mask+0, 0
	MOVWF      FARG_write_tca9535_w_data+0
	CALL       _write_tca9535+0
	GOTO       L__display_char48
L__display_char60:
L__display_char48:
;ThrottleMonitor2.mbas,283 :: 		end sub
L_end_display_char:
	RETURN
; end of _display_char

_decode_number:

;ThrottleMonitor2.mbas,288 :: 		sub function decode_number(dim number as byte) as byte
;ThrottleMonitor2.mbas,290 :: 		case 0 result = DIGIT_MASK_0
	MOVF       FARG_decode_number_number+0, 0
	XORLW      0
	BTFSS      STATUS+0, 2
	GOTO       L__decode_number65
	MOVLW      72
	MOVWF      R1+0
	GOTO       L__decode_number62
L__decode_number65:
;ThrottleMonitor2.mbas,291 :: 		case 1 result = DIGIT_MASK_1
	MOVF       FARG_decode_number_number+0, 0
	XORLW      1
	BTFSS      STATUS+0, 2
	GOTO       L__decode_number68
	MOVLW      237
	MOVWF      R1+0
	GOTO       L__decode_number62
L__decode_number68:
;ThrottleMonitor2.mbas,292 :: 		case 2 result = DIGIT_MASK_2
	MOVF       FARG_decode_number_number+0, 0
	XORLW      2
	BTFSS      STATUS+0, 2
	GOTO       L__decode_number71
	MOVLW      152
	MOVWF      R1+0
	GOTO       L__decode_number62
L__decode_number71:
;ThrottleMonitor2.mbas,293 :: 		case 3 result = DIGIT_MASK_3
	MOVF       FARG_decode_number_number+0, 0
	XORLW      3
	BTFSS      STATUS+0, 2
	GOTO       L__decode_number74
	MOVLW      137
	MOVWF      R1+0
	GOTO       L__decode_number62
L__decode_number74:
;ThrottleMonitor2.mbas,294 :: 		case 4 result = DIGIT_MASK_4
	MOVF       FARG_decode_number_number+0, 0
	XORLW      4
	BTFSS      STATUS+0, 2
	GOTO       L__decode_number77
	MOVLW      45
	MOVWF      R1+0
	GOTO       L__decode_number62
L__decode_number77:
;ThrottleMonitor2.mbas,295 :: 		case 5 result = DIGIT_MASK_5
	MOVF       FARG_decode_number_number+0, 0
	XORLW      5
	BTFSS      STATUS+0, 2
	GOTO       L__decode_number80
	MOVLW      11
	MOVWF      R1+0
	GOTO       L__decode_number62
L__decode_number80:
;ThrottleMonitor2.mbas,296 :: 		case 6 result = DIGIT_MASK_6
	MOVF       FARG_decode_number_number+0, 0
	XORLW      6
	BTFSS      STATUS+0, 2
	GOTO       L__decode_number83
	MOVLW      10
	MOVWF      R1+0
	GOTO       L__decode_number62
L__decode_number83:
;ThrottleMonitor2.mbas,297 :: 		case 7 result = DIGIT_MASK_7
	MOVF       FARG_decode_number_number+0, 0
	XORLW      7
	BTFSS      STATUS+0, 2
	GOTO       L__decode_number86
	MOVLW      233
	MOVWF      R1+0
	GOTO       L__decode_number62
L__decode_number86:
;ThrottleMonitor2.mbas,298 :: 		case 8 result = DIGIT_MASK_8
	MOVF       FARG_decode_number_number+0, 0
	XORLW      8
	BTFSS      STATUS+0, 2
	GOTO       L__decode_number89
	MOVLW      8
	MOVWF      R1+0
	GOTO       L__decode_number62
L__decode_number89:
;ThrottleMonitor2.mbas,299 :: 		case 9 result = DIGIT_MASK_9
	MOVF       FARG_decode_number_number+0, 0
	XORLW      9
	BTFSS      STATUS+0, 2
	GOTO       L__decode_number92
	MOVLW      9
	MOVWF      R1+0
	GOTO       L__decode_number62
L__decode_number92:
L__decode_number62:
;ThrottleMonitor2.mbas,301 :: 		end sub
	MOVF       R1+0, 0
	MOVWF      R0
L_end_decode_number:
	RETURN
; end of _decode_number

_decode_barcode:

;ThrottleMonitor2.mbas,306 :: 		sub function decode_barcode(dim level as byte) as byte
;ThrottleMonitor2.mbas,308 :: 		case 0 result = %11111111
	MOVF       FARG_decode_barcode_level+0, 0
	XORLW      0
	BTFSS      STATUS+0, 2
	GOTO       L__decode_barcode97
	MOVLW      255
	MOVWF      R1+0
	GOTO       L__decode_barcode94
L__decode_barcode97:
;ThrottleMonitor2.mbas,309 :: 		case 1 result = %11111110
	MOVF       FARG_decode_barcode_level+0, 0
	XORLW      1
	BTFSS      STATUS+0, 2
	GOTO       L__decode_barcode100
	MOVLW      254
	MOVWF      R1+0
	GOTO       L__decode_barcode94
L__decode_barcode100:
;ThrottleMonitor2.mbas,310 :: 		case 2 result = %11111100
	MOVF       FARG_decode_barcode_level+0, 0
	XORLW      2
	BTFSS      STATUS+0, 2
	GOTO       L__decode_barcode103
	MOVLW      252
	MOVWF      R1+0
	GOTO       L__decode_barcode94
L__decode_barcode103:
;ThrottleMonitor2.mbas,311 :: 		case 3 result = %11111000
	MOVF       FARG_decode_barcode_level+0, 0
	XORLW      3
	BTFSS      STATUS+0, 2
	GOTO       L__decode_barcode106
	MOVLW      248
	MOVWF      R1+0
	GOTO       L__decode_barcode94
L__decode_barcode106:
;ThrottleMonitor2.mbas,312 :: 		case 4 result = %11110000
	MOVF       FARG_decode_barcode_level+0, 0
	XORLW      4
	BTFSS      STATUS+0, 2
	GOTO       L__decode_barcode109
	MOVLW      240
	MOVWF      R1+0
	GOTO       L__decode_barcode94
L__decode_barcode109:
;ThrottleMonitor2.mbas,313 :: 		case 5 result = %11100000
	MOVF       FARG_decode_barcode_level+0, 0
	XORLW      5
	BTFSS      STATUS+0, 2
	GOTO       L__decode_barcode112
	MOVLW      224
	MOVWF      R1+0
	GOTO       L__decode_barcode94
L__decode_barcode112:
;ThrottleMonitor2.mbas,314 :: 		case 6 result = %11000000
	MOVF       FARG_decode_barcode_level+0, 0
	XORLW      6
	BTFSS      STATUS+0, 2
	GOTO       L__decode_barcode115
	MOVLW      192
	MOVWF      R1+0
	GOTO       L__decode_barcode94
L__decode_barcode115:
;ThrottleMonitor2.mbas,315 :: 		case 7 result = %10000000
	MOVF       FARG_decode_barcode_level+0, 0
	XORLW      7
	BTFSS      STATUS+0, 2
	GOTO       L__decode_barcode118
	MOVLW      128
	MOVWF      R1+0
	GOTO       L__decode_barcode94
L__decode_barcode118:
;ThrottleMonitor2.mbas,316 :: 		case 8 result = %00000000
	MOVF       FARG_decode_barcode_level+0, 0
	XORLW      8
	BTFSS      STATUS+0, 2
	GOTO       L__decode_barcode121
	CLRF       R1+0
	GOTO       L__decode_barcode94
L__decode_barcode121:
L__decode_barcode94:
;ThrottleMonitor2.mbas,318 :: 		end sub
	MOVF       R1+0, 0
	MOVWF      R0
L_end_decode_barcode:
	RETURN
; end of _decode_barcode

_decode_barcode_backword:

;ThrottleMonitor2.mbas,320 :: 		sub function decode_barcode_backword(dim level as byte) as byte
;ThrottleMonitor2.mbas,322 :: 		case 0 result = %11111111
	MOVF       FARG_decode_barcode_backword_level+0, 0
	XORLW      0
	BTFSS      STATUS+0, 2
	GOTO       L__decode_barcode_backword126
	MOVLW      255
	MOVWF      R1+0
	GOTO       L__decode_barcode_backword123
L__decode_barcode_backword126:
;ThrottleMonitor2.mbas,323 :: 		case 1 result = %01111111
	MOVF       FARG_decode_barcode_backword_level+0, 0
	XORLW      1
	BTFSS      STATUS+0, 2
	GOTO       L__decode_barcode_backword129
	MOVLW      127
	MOVWF      R1+0
	GOTO       L__decode_barcode_backword123
L__decode_barcode_backword129:
;ThrottleMonitor2.mbas,324 :: 		case 2 result = %00111111
	MOVF       FARG_decode_barcode_backword_level+0, 0
	XORLW      2
	BTFSS      STATUS+0, 2
	GOTO       L__decode_barcode_backword132
	MOVLW      63
	MOVWF      R1+0
	GOTO       L__decode_barcode_backword123
L__decode_barcode_backword132:
;ThrottleMonitor2.mbas,325 :: 		case 3 result = %00011111
	MOVF       FARG_decode_barcode_backword_level+0, 0
	XORLW      3
	BTFSS      STATUS+0, 2
	GOTO       L__decode_barcode_backword135
	MOVLW      31
	MOVWF      R1+0
	GOTO       L__decode_barcode_backword123
L__decode_barcode_backword135:
;ThrottleMonitor2.mbas,326 :: 		case 4 result = %00001111
	MOVF       FARG_decode_barcode_backword_level+0, 0
	XORLW      4
	BTFSS      STATUS+0, 2
	GOTO       L__decode_barcode_backword138
	MOVLW      15
	MOVWF      R1+0
	GOTO       L__decode_barcode_backword123
L__decode_barcode_backword138:
;ThrottleMonitor2.mbas,327 :: 		case 5 result = %00000111
	MOVF       FARG_decode_barcode_backword_level+0, 0
	XORLW      5
	BTFSS      STATUS+0, 2
	GOTO       L__decode_barcode_backword141
	MOVLW      7
	MOVWF      R1+0
	GOTO       L__decode_barcode_backword123
L__decode_barcode_backword141:
;ThrottleMonitor2.mbas,328 :: 		case 6 result = %00000011
	MOVF       FARG_decode_barcode_backword_level+0, 0
	XORLW      6
	BTFSS      STATUS+0, 2
	GOTO       L__decode_barcode_backword144
	MOVLW      3
	MOVWF      R1+0
	GOTO       L__decode_barcode_backword123
L__decode_barcode_backword144:
;ThrottleMonitor2.mbas,329 :: 		case 7 result = %00000001
	MOVF       FARG_decode_barcode_backword_level+0, 0
	XORLW      7
	BTFSS      STATUS+0, 2
	GOTO       L__decode_barcode_backword147
	MOVLW      1
	MOVWF      R1+0
	GOTO       L__decode_barcode_backword123
L__decode_barcode_backword147:
;ThrottleMonitor2.mbas,330 :: 		case 8 result = %00000000
	MOVF       FARG_decode_barcode_backword_level+0, 0
	XORLW      8
	BTFSS      STATUS+0, 2
	GOTO       L__decode_barcode_backword150
	CLRF       R1+0
	GOTO       L__decode_barcode_backword123
L__decode_barcode_backword150:
L__decode_barcode_backword123:
;ThrottleMonitor2.mbas,332 :: 		end sub
	MOVF       R1+0, 0
	MOVWF      R0
L_end_decode_barcode_backword:
	RETURN
; end of _decode_barcode_backword

_decode_barcode_reverse:

;ThrottleMonitor2.mbas,334 :: 		sub function decode_barcode_reverse(dim level as byte) as byte
;ThrottleMonitor2.mbas,336 :: 		case 0 result = %00000000
	MOVF       FARG_decode_barcode_reverse_level+0, 0
	XORLW      0
	BTFSS      STATUS+0, 2
	GOTO       L__decode_barcode_reverse155
	CLRF       R1+0
	GOTO       L__decode_barcode_reverse152
L__decode_barcode_reverse155:
;ThrottleMonitor2.mbas,337 :: 		case 1 result = %00000001
	MOVF       FARG_decode_barcode_reverse_level+0, 0
	XORLW      1
	BTFSS      STATUS+0, 2
	GOTO       L__decode_barcode_reverse158
	MOVLW      1
	MOVWF      R1+0
	GOTO       L__decode_barcode_reverse152
L__decode_barcode_reverse158:
;ThrottleMonitor2.mbas,338 :: 		case 2 result = %00000011
	MOVF       FARG_decode_barcode_reverse_level+0, 0
	XORLW      2
	BTFSS      STATUS+0, 2
	GOTO       L__decode_barcode_reverse161
	MOVLW      3
	MOVWF      R1+0
	GOTO       L__decode_barcode_reverse152
L__decode_barcode_reverse161:
;ThrottleMonitor2.mbas,339 :: 		case 3 result = %00000111
	MOVF       FARG_decode_barcode_reverse_level+0, 0
	XORLW      3
	BTFSS      STATUS+0, 2
	GOTO       L__decode_barcode_reverse164
	MOVLW      7
	MOVWF      R1+0
	GOTO       L__decode_barcode_reverse152
L__decode_barcode_reverse164:
;ThrottleMonitor2.mbas,340 :: 		case 4 result = %00001111
	MOVF       FARG_decode_barcode_reverse_level+0, 0
	XORLW      4
	BTFSS      STATUS+0, 2
	GOTO       L__decode_barcode_reverse167
	MOVLW      15
	MOVWF      R1+0
	GOTO       L__decode_barcode_reverse152
L__decode_barcode_reverse167:
;ThrottleMonitor2.mbas,341 :: 		case 5 result = %00011111
	MOVF       FARG_decode_barcode_reverse_level+0, 0
	XORLW      5
	BTFSS      STATUS+0, 2
	GOTO       L__decode_barcode_reverse170
	MOVLW      31
	MOVWF      R1+0
	GOTO       L__decode_barcode_reverse152
L__decode_barcode_reverse170:
;ThrottleMonitor2.mbas,342 :: 		case 6 result = %00111111
	MOVF       FARG_decode_barcode_reverse_level+0, 0
	XORLW      6
	BTFSS      STATUS+0, 2
	GOTO       L__decode_barcode_reverse173
	MOVLW      63
	MOVWF      R1+0
	GOTO       L__decode_barcode_reverse152
L__decode_barcode_reverse173:
;ThrottleMonitor2.mbas,343 :: 		case 7 result = %01111111
	MOVF       FARG_decode_barcode_reverse_level+0, 0
	XORLW      7
	BTFSS      STATUS+0, 2
	GOTO       L__decode_barcode_reverse176
	MOVLW      127
	MOVWF      R1+0
	GOTO       L__decode_barcode_reverse152
L__decode_barcode_reverse176:
;ThrottleMonitor2.mbas,344 :: 		case 8 result = %11111111
	MOVF       FARG_decode_barcode_reverse_level+0, 0
	XORLW      8
	BTFSS      STATUS+0, 2
	GOTO       L__decode_barcode_reverse179
	MOVLW      255
	MOVWF      R1+0
	GOTO       L__decode_barcode_reverse152
L__decode_barcode_reverse179:
L__decode_barcode_reverse152:
;ThrottleMonitor2.mbas,346 :: 		end sub
	MOVF       R1+0, 0
	MOVWF      R0
L_end_decode_barcode_reverse:
	RETURN
; end of _decode_barcode_reverse

_display_throttle:

;ThrottleMonitor2.mbas,353 :: 		sub procedure display_throttle(dim throttle_position as byte)
;ThrottleMonitor2.mbas,354 :: 		if 8 < throttle_position then
	MOVF       FARG_display_throttle_throttle_position+0, 0
	SUBLW      8
	BTFSC      STATUS+0, 0
	GOTO       L__display_throttle182
;ThrottleMonitor2.mbas,355 :: 		write_tca9535( IOEXPANDER_DEVICE_ID0, TCA9535_OUTPUT_PORT0, LED_ALL_ON )
	CLRF       FARG_write_tca9535_device_address+0
	MOVLW      2
	MOVWF      FARG_write_tca9535_command_byte+0
	CLRF       FARG_write_tca9535_w_data+0
	CALL       _write_tca9535+0
;ThrottleMonitor2.mbas,356 :: 		throttle_position = throttle_position - 8
	MOVLW      8
	SUBWF      FARG_display_throttle_throttle_position+0, 0
	MOVWF      R1
	MOVF       R1, 0
	MOVWF      FARG_display_throttle_throttle_position+0
;ThrottleMonitor2.mbas,357 :: 		if 8 < throttle_position then
	MOVF       R1, 0
	SUBLW      8
	BTFSC      STATUS+0, 0
	GOTO       L__display_throttle185
;ThrottleMonitor2.mbas,358 :: 		write_tca9535( IOEXPANDER_DEVICE_ID0, TCA9535_OUTPUT_PORT1, LED_ALL_ON )
	CLRF       FARG_write_tca9535_device_address+0
	MOVLW      3
	MOVWF      FARG_write_tca9535_command_byte+0
	CLRF       FARG_write_tca9535_w_data+0
	CALL       _write_tca9535+0
;ThrottleMonitor2.mbas,359 :: 		throttle_position = throttle_position - 8
	MOVLW      8
	SUBWF      FARG_display_throttle_throttle_position+0, 0
	MOVWF      R0
	MOVF       R0, 0
	MOVWF      FARG_display_throttle_throttle_position+0
;ThrottleMonitor2.mbas,360 :: 		write_tca9535( IOEXPANDER_DEVICE_ID1, TCA9535_OUTPUT_PORT0, decode_barcode(throttle_position) )
	MOVF       R0, 0
	MOVWF      FARG_decode_barcode_level+0
	CALL       _decode_barcode+0
	MOVF       R0, 0
	MOVWF      FARG_write_tca9535_w_data+0
	MOVLW      2
	MOVWF      FARG_write_tca9535_device_address+0
	MOVLW      2
	MOVWF      FARG_write_tca9535_command_byte+0
	CALL       _write_tca9535+0
	GOTO       L__display_throttle186
;ThrottleMonitor2.mbas,361 :: 		else
L__display_throttle185:
;ThrottleMonitor2.mbas,362 :: 		write_tca9535( IOEXPANDER_DEVICE_ID1, TCA9535_OUTPUT_PORT0, LED_ALL_OFF )
	MOVLW      2
	MOVWF      FARG_write_tca9535_device_address+0
	MOVLW      2
	MOVWF      FARG_write_tca9535_command_byte+0
	MOVLW      255
	MOVWF      FARG_write_tca9535_w_data+0
	CALL       _write_tca9535+0
;ThrottleMonitor2.mbas,363 :: 		write_tca9535( IOEXPANDER_DEVICE_ID0, TCA9535_OUTPUT_PORT1, decode_barcode(throttle_position) )
	MOVF       FARG_display_throttle_throttle_position+0, 0
	MOVWF      FARG_decode_barcode_level+0
	CALL       _decode_barcode+0
	MOVF       R0, 0
	MOVWF      FARG_write_tca9535_w_data+0
	CLRF       FARG_write_tca9535_device_address+0
	MOVLW      3
	MOVWF      FARG_write_tca9535_command_byte+0
	CALL       _write_tca9535+0
;ThrottleMonitor2.mbas,364 :: 		end if
L__display_throttle186:
	GOTO       L__display_throttle183
;ThrottleMonitor2.mbas,365 :: 		else
L__display_throttle182:
;ThrottleMonitor2.mbas,366 :: 		write_tca9535( IOEXPANDER_DEVICE_ID0, TCA9535_OUTPUT_PORT0, decode_barcode(throttle_position) )
	MOVF       FARG_display_throttle_throttle_position+0, 0
	MOVWF      FARG_decode_barcode_level+0
	CALL       _decode_barcode+0
	MOVF       R0, 0
	MOVWF      FARG_write_tca9535_w_data+0
	CLRF       FARG_write_tca9535_device_address+0
	MOVLW      2
	MOVWF      FARG_write_tca9535_command_byte+0
	CALL       _write_tca9535+0
;ThrottleMonitor2.mbas,367 :: 		write_tca9535( IOEXPANDER_DEVICE_ID0, TCA9535_OUTPUT_PORT1, LED_ALL_OFF )
	CLRF       FARG_write_tca9535_device_address+0
	MOVLW      3
	MOVWF      FARG_write_tca9535_command_byte+0
	MOVLW      255
	MOVWF      FARG_write_tca9535_w_data+0
	CALL       _write_tca9535+0
;ThrottleMonitor2.mbas,368 :: 		write_tca9535( IOEXPANDER_DEVICE_ID1, TCA9535_OUTPUT_PORT0, LED_ALL_OFF )
	MOVLW      2
	MOVWF      FARG_write_tca9535_device_address+0
	MOVLW      2
	MOVWF      FARG_write_tca9535_command_byte+0
	MOVLW      255
	MOVWF      FARG_write_tca9535_w_data+0
	CALL       _write_tca9535+0
;ThrottleMonitor2.mbas,369 :: 		end if
L__display_throttle183:
;ThrottleMonitor2.mbas,370 :: 		end sub
L_end_display_throttle:
	RETURN
; end of _display_throttle

_display_rpm:

;ThrottleMonitor2.mbas,377 :: 		sub procedure display_rpm(dim rpm as byte)
;ThrottleMonitor2.mbas,378 :: 		if 32 < rpm then
	MOVF       FARG_display_rpm_rpm+0, 0
	SUBLW      32
	BTFSC      STATUS+0, 0
	GOTO       L__display_rpm189
;ThrottleMonitor2.mbas,379 :: 		write_tca9535( IOEXPANDER_DEVICE_ID4, TCA9535_OUTPUT_PORT0, LED_ALL_ON  )
	MOVLW      8
	MOVWF      FARG_write_tca9535_device_address+0
	MOVLW      2
	MOVWF      FARG_write_tca9535_command_byte+0
	CLRF       FARG_write_tca9535_w_data+0
	CALL       _write_tca9535+0
;ThrottleMonitor2.mbas,380 :: 		write_tca9535( IOEXPANDER_DEVICE_ID4, TCA9535_OUTPUT_PORT1, LED_ALL_ON  )
	MOVLW      8
	MOVWF      FARG_write_tca9535_device_address+0
	MOVLW      3
	MOVWF      FARG_write_tca9535_command_byte+0
	CLRF       FARG_write_tca9535_w_data+0
	CALL       _write_tca9535+0
;ThrottleMonitor2.mbas,381 :: 		write_tca9535( IOEXPANDER_DEVICE_ID5, TCA9535_OUTPUT_PORT0, LED_ALL_ON  )
	MOVLW      10
	MOVWF      FARG_write_tca9535_device_address+0
	MOVLW      2
	MOVWF      FARG_write_tca9535_command_byte+0
	CLRF       FARG_write_tca9535_w_data+0
	CALL       _write_tca9535+0
;ThrottleMonitor2.mbas,382 :: 		write_tca9535( IOEXPANDER_DEVICE_ID5, TCA9535_OUTPUT_PORT1, LED_ALL_ON  )
	MOVLW      10
	MOVWF      FARG_write_tca9535_device_address+0
	MOVLW      3
	MOVWF      FARG_write_tca9535_command_byte+0
	CLRF       FARG_write_tca9535_w_data+0
	CALL       _write_tca9535+0
;ThrottleMonitor2.mbas,383 :: 		write_tca9535( IOEXPANDER_DEVICE_ID6, TCA9535_OUTPUT_PORT0, decode_barcode(rpm-32) )
	MOVLW      32
	SUBWF      FARG_display_rpm_rpm+0, 0
	MOVWF      FARG_decode_barcode_level+0
	CALL       _decode_barcode+0
	MOVF       R0, 0
	MOVWF      FARG_write_tca9535_w_data+0
	MOVLW      12
	MOVWF      FARG_write_tca9535_device_address+0
	MOVLW      2
	MOVWF      FARG_write_tca9535_command_byte+0
	CALL       _write_tca9535+0
	GOTO       L__display_rpm190
;ThrottleMonitor2.mbas,384 :: 		else if 24 < rpm then
L__display_rpm189:
	MOVF       FARG_display_rpm_rpm+0, 0
	SUBLW      24
	BTFSC      STATUS+0, 0
	GOTO       L__display_rpm192
;ThrottleMonitor2.mbas,385 :: 		write_tca9535( IOEXPANDER_DEVICE_ID4, TCA9535_OUTPUT_PORT0, LED_ALL_ON  )
	MOVLW      8
	MOVWF      FARG_write_tca9535_device_address+0
	MOVLW      2
	MOVWF      FARG_write_tca9535_command_byte+0
	CLRF       FARG_write_tca9535_w_data+0
	CALL       _write_tca9535+0
;ThrottleMonitor2.mbas,386 :: 		write_tca9535( IOEXPANDER_DEVICE_ID4, TCA9535_OUTPUT_PORT1, LED_ALL_ON  )
	MOVLW      8
	MOVWF      FARG_write_tca9535_device_address+0
	MOVLW      3
	MOVWF      FARG_write_tca9535_command_byte+0
	CLRF       FARG_write_tca9535_w_data+0
	CALL       _write_tca9535+0
;ThrottleMonitor2.mbas,387 :: 		write_tca9535( IOEXPANDER_DEVICE_ID5, TCA9535_OUTPUT_PORT0, LED_ALL_ON  )
	MOVLW      10
	MOVWF      FARG_write_tca9535_device_address+0
	MOVLW      2
	MOVWF      FARG_write_tca9535_command_byte+0
	CLRF       FARG_write_tca9535_w_data+0
	CALL       _write_tca9535+0
;ThrottleMonitor2.mbas,388 :: 		write_tca9535( IOEXPANDER_DEVICE_ID5, TCA9535_OUTPUT_PORT1, decode_barcode(rpm-24) )
	MOVLW      24
	SUBWF      FARG_display_rpm_rpm+0, 0
	MOVWF      FARG_decode_barcode_level+0
	CALL       _decode_barcode+0
	MOVF       R0, 0
	MOVWF      FARG_write_tca9535_w_data+0
	MOVLW      10
	MOVWF      FARG_write_tca9535_device_address+0
	MOVLW      3
	MOVWF      FARG_write_tca9535_command_byte+0
	CALL       _write_tca9535+0
;ThrottleMonitor2.mbas,389 :: 		write_tca9535( IOEXPANDER_DEVICE_ID6, TCA9535_OUTPUT_PORT0, LED_ALL_OFF )
	MOVLW      12
	MOVWF      FARG_write_tca9535_device_address+0
	MOVLW      2
	MOVWF      FARG_write_tca9535_command_byte+0
	MOVLW      255
	MOVWF      FARG_write_tca9535_w_data+0
	CALL       _write_tca9535+0
	GOTO       L__display_rpm193
;ThrottleMonitor2.mbas,390 :: 		else if 16 < rpm then
L__display_rpm192:
	MOVF       FARG_display_rpm_rpm+0, 0
	SUBLW      16
	BTFSC      STATUS+0, 0
	GOTO       L__display_rpm195
;ThrottleMonitor2.mbas,391 :: 		write_tca9535( IOEXPANDER_DEVICE_ID4, TCA9535_OUTPUT_PORT0, LED_ALL_ON  )
	MOVLW      8
	MOVWF      FARG_write_tca9535_device_address+0
	MOVLW      2
	MOVWF      FARG_write_tca9535_command_byte+0
	CLRF       FARG_write_tca9535_w_data+0
	CALL       _write_tca9535+0
;ThrottleMonitor2.mbas,392 :: 		write_tca9535( IOEXPANDER_DEVICE_ID4, TCA9535_OUTPUT_PORT1, LED_ALL_ON  )
	MOVLW      8
	MOVWF      FARG_write_tca9535_device_address+0
	MOVLW      3
	MOVWF      FARG_write_tca9535_command_byte+0
	CLRF       FARG_write_tca9535_w_data+0
	CALL       _write_tca9535+0
;ThrottleMonitor2.mbas,393 :: 		write_tca9535( IOEXPANDER_DEVICE_ID5, TCA9535_OUTPUT_PORT0, decode_barcode(rpm-16) )
	MOVLW      16
	SUBWF      FARG_display_rpm_rpm+0, 0
	MOVWF      FARG_decode_barcode_level+0
	CALL       _decode_barcode+0
	MOVF       R0, 0
	MOVWF      FARG_write_tca9535_w_data+0
	MOVLW      10
	MOVWF      FARG_write_tca9535_device_address+0
	MOVLW      2
	MOVWF      FARG_write_tca9535_command_byte+0
	CALL       _write_tca9535+0
;ThrottleMonitor2.mbas,394 :: 		write_tca9535( IOEXPANDER_DEVICE_ID5, TCA9535_OUTPUT_PORT1, LED_ALL_OFF )
	MOVLW      10
	MOVWF      FARG_write_tca9535_device_address+0
	MOVLW      3
	MOVWF      FARG_write_tca9535_command_byte+0
	MOVLW      255
	MOVWF      FARG_write_tca9535_w_data+0
	CALL       _write_tca9535+0
;ThrottleMonitor2.mbas,395 :: 		write_tca9535( IOEXPANDER_DEVICE_ID6, TCA9535_OUTPUT_PORT0, LED_ALL_OFF )
	MOVLW      12
	MOVWF      FARG_write_tca9535_device_address+0
	MOVLW      2
	MOVWF      FARG_write_tca9535_command_byte+0
	MOVLW      255
	MOVWF      FARG_write_tca9535_w_data+0
	CALL       _write_tca9535+0
	GOTO       L__display_rpm196
;ThrottleMonitor2.mbas,396 :: 		else if 8 < rpm then
L__display_rpm195:
	MOVF       FARG_display_rpm_rpm+0, 0
	SUBLW      8
	BTFSC      STATUS+0, 0
	GOTO       L__display_rpm198
;ThrottleMonitor2.mbas,397 :: 		write_tca9535( IOEXPANDER_DEVICE_ID4, TCA9535_OUTPUT_PORT0, LED_ALL_ON  )
	MOVLW      8
	MOVWF      FARG_write_tca9535_device_address+0
	MOVLW      2
	MOVWF      FARG_write_tca9535_command_byte+0
	CLRF       FARG_write_tca9535_w_data+0
	CALL       _write_tca9535+0
;ThrottleMonitor2.mbas,398 :: 		write_tca9535( IOEXPANDER_DEVICE_ID4, TCA9535_OUTPUT_PORT1, decode_barcode(rpm-8) )
	MOVLW      8
	SUBWF      FARG_display_rpm_rpm+0, 0
	MOVWF      FARG_decode_barcode_level+0
	CALL       _decode_barcode+0
	MOVF       R0, 0
	MOVWF      FARG_write_tca9535_w_data+0
	MOVLW      8
	MOVWF      FARG_write_tca9535_device_address+0
	MOVLW      3
	MOVWF      FARG_write_tca9535_command_byte+0
	CALL       _write_tca9535+0
;ThrottleMonitor2.mbas,399 :: 		write_tca9535( IOEXPANDER_DEVICE_ID5, TCA9535_OUTPUT_PORT0, LED_ALL_OFF )
	MOVLW      10
	MOVWF      FARG_write_tca9535_device_address+0
	MOVLW      2
	MOVWF      FARG_write_tca9535_command_byte+0
	MOVLW      255
	MOVWF      FARG_write_tca9535_w_data+0
	CALL       _write_tca9535+0
;ThrottleMonitor2.mbas,400 :: 		write_tca9535( IOEXPANDER_DEVICE_ID5, TCA9535_OUTPUT_PORT1, LED_ALL_OFF )
	MOVLW      10
	MOVWF      FARG_write_tca9535_device_address+0
	MOVLW      3
	MOVWF      FARG_write_tca9535_command_byte+0
	MOVLW      255
	MOVWF      FARG_write_tca9535_w_data+0
	CALL       _write_tca9535+0
;ThrottleMonitor2.mbas,401 :: 		write_tca9535( IOEXPANDER_DEVICE_ID6, TCA9535_OUTPUT_PORT0, LED_ALL_OFF )
	MOVLW      12
	MOVWF      FARG_write_tca9535_device_address+0
	MOVLW      2
	MOVWF      FARG_write_tca9535_command_byte+0
	MOVLW      255
	MOVWF      FARG_write_tca9535_w_data+0
	CALL       _write_tca9535+0
	GOTO       L__display_rpm199
;ThrottleMonitor2.mbas,402 :: 		else
L__display_rpm198:
;ThrottleMonitor2.mbas,403 :: 		write_tca9535( IOEXPANDER_DEVICE_ID4, TCA9535_OUTPUT_PORT0, decode_barcode(rpm) )
	MOVF       FARG_display_rpm_rpm+0, 0
	MOVWF      FARG_decode_barcode_level+0
	CALL       _decode_barcode+0
	MOVF       R0, 0
	MOVWF      FARG_write_tca9535_w_data+0
	MOVLW      8
	MOVWF      FARG_write_tca9535_device_address+0
	MOVLW      2
	MOVWF      FARG_write_tca9535_command_byte+0
	CALL       _write_tca9535+0
;ThrottleMonitor2.mbas,404 :: 		write_tca9535( IOEXPANDER_DEVICE_ID4, TCA9535_OUTPUT_PORT1, LED_ALL_OFF )
	MOVLW      8
	MOVWF      FARG_write_tca9535_device_address+0
	MOVLW      3
	MOVWF      FARG_write_tca9535_command_byte+0
	MOVLW      255
	MOVWF      FARG_write_tca9535_w_data+0
	CALL       _write_tca9535+0
;ThrottleMonitor2.mbas,405 :: 		write_tca9535( IOEXPANDER_DEVICE_ID5, TCA9535_OUTPUT_PORT0, LED_ALL_OFF )
	MOVLW      10
	MOVWF      FARG_write_tca9535_device_address+0
	MOVLW      2
	MOVWF      FARG_write_tca9535_command_byte+0
	MOVLW      255
	MOVWF      FARG_write_tca9535_w_data+0
	CALL       _write_tca9535+0
;ThrottleMonitor2.mbas,406 :: 		write_tca9535( IOEXPANDER_DEVICE_ID5, TCA9535_OUTPUT_PORT1, LED_ALL_OFF )
	MOVLW      10
	MOVWF      FARG_write_tca9535_device_address+0
	MOVLW      3
	MOVWF      FARG_write_tca9535_command_byte+0
	MOVLW      255
	MOVWF      FARG_write_tca9535_w_data+0
	CALL       _write_tca9535+0
;ThrottleMonitor2.mbas,407 :: 		write_tca9535( IOEXPANDER_DEVICE_ID6, TCA9535_OUTPUT_PORT0, LED_ALL_OFF )
	MOVLW      12
	MOVWF      FARG_write_tca9535_device_address+0
	MOVLW      2
	MOVWF      FARG_write_tca9535_command_byte+0
	MOVLW      255
	MOVWF      FARG_write_tca9535_w_data+0
	CALL       _write_tca9535+0
;ThrottleMonitor2.mbas,408 :: 		end if  end if  end if  end if
L__display_rpm199:
L__display_rpm196:
L__display_rpm193:
L__display_rpm190:
;ThrottleMonitor2.mbas,409 :: 		end sub
L_end_display_rpm:
	RETURN
; end of _display_rpm

_display_rpm_reverse:

;ThrottleMonitor2.mbas,411 :: 		sub procedure display_rpm_reverse(dim rpm as byte)
;ThrottleMonitor2.mbas,412 :: 		if 32 < rpm then
	MOVF       FARG_display_rpm_reverse_rpm+0, 0
	SUBLW      32
	BTFSC      STATUS+0, 0
	GOTO       L__display_rpm_reverse202
;ThrottleMonitor2.mbas,413 :: 		write_tca9535( IOEXPANDER_DEVICE_ID4, TCA9535_OUTPUT_PORT0, LED_ALL_OFF )
	MOVLW      8
	MOVWF      FARG_write_tca9535_device_address+0
	MOVLW      2
	MOVWF      FARG_write_tca9535_command_byte+0
	MOVLW      255
	MOVWF      FARG_write_tca9535_w_data+0
	CALL       _write_tca9535+0
;ThrottleMonitor2.mbas,414 :: 		write_tca9535( IOEXPANDER_DEVICE_ID4, TCA9535_OUTPUT_PORT1, LED_ALL_OFF )
	MOVLW      8
	MOVWF      FARG_write_tca9535_device_address+0
	MOVLW      3
	MOVWF      FARG_write_tca9535_command_byte+0
	MOVLW      255
	MOVWF      FARG_write_tca9535_w_data+0
	CALL       _write_tca9535+0
;ThrottleMonitor2.mbas,415 :: 		write_tca9535( IOEXPANDER_DEVICE_ID5, TCA9535_OUTPUT_PORT0, LED_ALL_OFF )
	MOVLW      10
	MOVWF      FARG_write_tca9535_device_address+0
	MOVLW      2
	MOVWF      FARG_write_tca9535_command_byte+0
	MOVLW      255
	MOVWF      FARG_write_tca9535_w_data+0
	CALL       _write_tca9535+0
;ThrottleMonitor2.mbas,416 :: 		write_tca9535( IOEXPANDER_DEVICE_ID5, TCA9535_OUTPUT_PORT1, LED_ALL_OFF )
	MOVLW      10
	MOVWF      FARG_write_tca9535_device_address+0
	MOVLW      3
	MOVWF      FARG_write_tca9535_command_byte+0
	MOVLW      255
	MOVWF      FARG_write_tca9535_w_data+0
	CALL       _write_tca9535+0
;ThrottleMonitor2.mbas,417 :: 		write_tca9535( IOEXPANDER_DEVICE_ID6, TCA9535_OUTPUT_PORT0, decode_barcode_reverse(rpm-32) )
	MOVLW      32
	SUBWF      FARG_display_rpm_reverse_rpm+0, 0
	MOVWF      FARG_decode_barcode_reverse_level+0
	CALL       _decode_barcode_reverse+0
	MOVF       R0, 0
	MOVWF      FARG_write_tca9535_w_data+0
	MOVLW      12
	MOVWF      FARG_write_tca9535_device_address+0
	MOVLW      2
	MOVWF      FARG_write_tca9535_command_byte+0
	CALL       _write_tca9535+0
	GOTO       L__display_rpm_reverse203
;ThrottleMonitor2.mbas,418 :: 		else if 24 < rpm then
L__display_rpm_reverse202:
	MOVF       FARG_display_rpm_reverse_rpm+0, 0
	SUBLW      24
	BTFSC      STATUS+0, 0
	GOTO       L__display_rpm_reverse205
;ThrottleMonitor2.mbas,419 :: 		write_tca9535( IOEXPANDER_DEVICE_ID4, TCA9535_OUTPUT_PORT0, LED_ALL_OFF )
	MOVLW      8
	MOVWF      FARG_write_tca9535_device_address+0
	MOVLW      2
	MOVWF      FARG_write_tca9535_command_byte+0
	MOVLW      255
	MOVWF      FARG_write_tca9535_w_data+0
	CALL       _write_tca9535+0
;ThrottleMonitor2.mbas,420 :: 		write_tca9535( IOEXPANDER_DEVICE_ID4, TCA9535_OUTPUT_PORT1, LED_ALL_OFF )
	MOVLW      8
	MOVWF      FARG_write_tca9535_device_address+0
	MOVLW      3
	MOVWF      FARG_write_tca9535_command_byte+0
	MOVLW      255
	MOVWF      FARG_write_tca9535_w_data+0
	CALL       _write_tca9535+0
;ThrottleMonitor2.mbas,421 :: 		write_tca9535( IOEXPANDER_DEVICE_ID5, TCA9535_OUTPUT_PORT0, LED_ALL_OFF )
	MOVLW      10
	MOVWF      FARG_write_tca9535_device_address+0
	MOVLW      2
	MOVWF      FARG_write_tca9535_command_byte+0
	MOVLW      255
	MOVWF      FARG_write_tca9535_w_data+0
	CALL       _write_tca9535+0
;ThrottleMonitor2.mbas,422 :: 		write_tca9535( IOEXPANDER_DEVICE_ID5, TCA9535_OUTPUT_PORT1, decode_barcode_reverse(rpm-24) )
	MOVLW      24
	SUBWF      FARG_display_rpm_reverse_rpm+0, 0
	MOVWF      FARG_decode_barcode_reverse_level+0
	CALL       _decode_barcode_reverse+0
	MOVF       R0, 0
	MOVWF      FARG_write_tca9535_w_data+0
	MOVLW      10
	MOVWF      FARG_write_tca9535_device_address+0
	MOVLW      3
	MOVWF      FARG_write_tca9535_command_byte+0
	CALL       _write_tca9535+0
;ThrottleMonitor2.mbas,423 :: 		write_tca9535( IOEXPANDER_DEVICE_ID6, TCA9535_OUTPUT_PORT0, LED_ALL_ON  )
	MOVLW      12
	MOVWF      FARG_write_tca9535_device_address+0
	MOVLW      2
	MOVWF      FARG_write_tca9535_command_byte+0
	CLRF       FARG_write_tca9535_w_data+0
	CALL       _write_tca9535+0
	GOTO       L__display_rpm_reverse206
;ThrottleMonitor2.mbas,424 :: 		else if 16 < rpm then
L__display_rpm_reverse205:
	MOVF       FARG_display_rpm_reverse_rpm+0, 0
	SUBLW      16
	BTFSC      STATUS+0, 0
	GOTO       L__display_rpm_reverse208
;ThrottleMonitor2.mbas,425 :: 		write_tca9535( IOEXPANDER_DEVICE_ID4, TCA9535_OUTPUT_PORT0, LED_ALL_OFF )
	MOVLW      8
	MOVWF      FARG_write_tca9535_device_address+0
	MOVLW      2
	MOVWF      FARG_write_tca9535_command_byte+0
	MOVLW      255
	MOVWF      FARG_write_tca9535_w_data+0
	CALL       _write_tca9535+0
;ThrottleMonitor2.mbas,426 :: 		write_tca9535( IOEXPANDER_DEVICE_ID4, TCA9535_OUTPUT_PORT1, LED_ALL_OFF )
	MOVLW      8
	MOVWF      FARG_write_tca9535_device_address+0
	MOVLW      3
	MOVWF      FARG_write_tca9535_command_byte+0
	MOVLW      255
	MOVWF      FARG_write_tca9535_w_data+0
	CALL       _write_tca9535+0
;ThrottleMonitor2.mbas,427 :: 		write_tca9535( IOEXPANDER_DEVICE_ID5, TCA9535_OUTPUT_PORT0, decode_barcode_reverse(rpm-16) )
	MOVLW      16
	SUBWF      FARG_display_rpm_reverse_rpm+0, 0
	MOVWF      FARG_decode_barcode_reverse_level+0
	CALL       _decode_barcode_reverse+0
	MOVF       R0, 0
	MOVWF      FARG_write_tca9535_w_data+0
	MOVLW      10
	MOVWF      FARG_write_tca9535_device_address+0
	MOVLW      2
	MOVWF      FARG_write_tca9535_command_byte+0
	CALL       _write_tca9535+0
;ThrottleMonitor2.mbas,428 :: 		write_tca9535( IOEXPANDER_DEVICE_ID5, TCA9535_OUTPUT_PORT1, LED_ALL_ON  )
	MOVLW      10
	MOVWF      FARG_write_tca9535_device_address+0
	MOVLW      3
	MOVWF      FARG_write_tca9535_command_byte+0
	CLRF       FARG_write_tca9535_w_data+0
	CALL       _write_tca9535+0
;ThrottleMonitor2.mbas,429 :: 		write_tca9535( IOEXPANDER_DEVICE_ID6, TCA9535_OUTPUT_PORT0, LED_ALL_ON  )
	MOVLW      12
	MOVWF      FARG_write_tca9535_device_address+0
	MOVLW      2
	MOVWF      FARG_write_tca9535_command_byte+0
	CLRF       FARG_write_tca9535_w_data+0
	CALL       _write_tca9535+0
	GOTO       L__display_rpm_reverse209
;ThrottleMonitor2.mbas,430 :: 		else if 8 < rpm then
L__display_rpm_reverse208:
	MOVF       FARG_display_rpm_reverse_rpm+0, 0
	SUBLW      8
	BTFSC      STATUS+0, 0
	GOTO       L__display_rpm_reverse211
;ThrottleMonitor2.mbas,431 :: 		write_tca9535( IOEXPANDER_DEVICE_ID4, TCA9535_OUTPUT_PORT0, LED_ALL_OFF )
	MOVLW      8
	MOVWF      FARG_write_tca9535_device_address+0
	MOVLW      2
	MOVWF      FARG_write_tca9535_command_byte+0
	MOVLW      255
	MOVWF      FARG_write_tca9535_w_data+0
	CALL       _write_tca9535+0
;ThrottleMonitor2.mbas,432 :: 		write_tca9535( IOEXPANDER_DEVICE_ID4, TCA9535_OUTPUT_PORT1, decode_barcode_reverse(rpm-8) )
	MOVLW      8
	SUBWF      FARG_display_rpm_reverse_rpm+0, 0
	MOVWF      FARG_decode_barcode_reverse_level+0
	CALL       _decode_barcode_reverse+0
	MOVF       R0, 0
	MOVWF      FARG_write_tca9535_w_data+0
	MOVLW      8
	MOVWF      FARG_write_tca9535_device_address+0
	MOVLW      3
	MOVWF      FARG_write_tca9535_command_byte+0
	CALL       _write_tca9535+0
;ThrottleMonitor2.mbas,433 :: 		write_tca9535( IOEXPANDER_DEVICE_ID5, TCA9535_OUTPUT_PORT0, LED_ALL_ON  )
	MOVLW      10
	MOVWF      FARG_write_tca9535_device_address+0
	MOVLW      2
	MOVWF      FARG_write_tca9535_command_byte+0
	CLRF       FARG_write_tca9535_w_data+0
	CALL       _write_tca9535+0
;ThrottleMonitor2.mbas,434 :: 		write_tca9535( IOEXPANDER_DEVICE_ID5, TCA9535_OUTPUT_PORT1, LED_ALL_ON  )
	MOVLW      10
	MOVWF      FARG_write_tca9535_device_address+0
	MOVLW      3
	MOVWF      FARG_write_tca9535_command_byte+0
	CLRF       FARG_write_tca9535_w_data+0
	CALL       _write_tca9535+0
;ThrottleMonitor2.mbas,435 :: 		write_tca9535( IOEXPANDER_DEVICE_ID6, TCA9535_OUTPUT_PORT0, LED_ALL_ON  )
	MOVLW      12
	MOVWF      FARG_write_tca9535_device_address+0
	MOVLW      2
	MOVWF      FARG_write_tca9535_command_byte+0
	CLRF       FARG_write_tca9535_w_data+0
	CALL       _write_tca9535+0
	GOTO       L__display_rpm_reverse212
;ThrottleMonitor2.mbas,436 :: 		else
L__display_rpm_reverse211:
;ThrottleMonitor2.mbas,437 :: 		write_tca9535( IOEXPANDER_DEVICE_ID4, TCA9535_OUTPUT_PORT0, decode_barcode_reverse(rpm) )
	MOVF       FARG_display_rpm_reverse_rpm+0, 0
	MOVWF      FARG_decode_barcode_reverse_level+0
	CALL       _decode_barcode_reverse+0
	MOVF       R0, 0
	MOVWF      FARG_write_tca9535_w_data+0
	MOVLW      8
	MOVWF      FARG_write_tca9535_device_address+0
	MOVLW      2
	MOVWF      FARG_write_tca9535_command_byte+0
	CALL       _write_tca9535+0
;ThrottleMonitor2.mbas,438 :: 		write_tca9535( IOEXPANDER_DEVICE_ID4, TCA9535_OUTPUT_PORT1, LED_ALL_ON  )
	MOVLW      8
	MOVWF      FARG_write_tca9535_device_address+0
	MOVLW      3
	MOVWF      FARG_write_tca9535_command_byte+0
	CLRF       FARG_write_tca9535_w_data+0
	CALL       _write_tca9535+0
;ThrottleMonitor2.mbas,439 :: 		write_tca9535( IOEXPANDER_DEVICE_ID5, TCA9535_OUTPUT_PORT0, LED_ALL_ON  )
	MOVLW      10
	MOVWF      FARG_write_tca9535_device_address+0
	MOVLW      2
	MOVWF      FARG_write_tca9535_command_byte+0
	CLRF       FARG_write_tca9535_w_data+0
	CALL       _write_tca9535+0
;ThrottleMonitor2.mbas,440 :: 		write_tca9535( IOEXPANDER_DEVICE_ID5, TCA9535_OUTPUT_PORT1, LED_ALL_ON  )
	MOVLW      10
	MOVWF      FARG_write_tca9535_device_address+0
	MOVLW      3
	MOVWF      FARG_write_tca9535_command_byte+0
	CLRF       FARG_write_tca9535_w_data+0
	CALL       _write_tca9535+0
;ThrottleMonitor2.mbas,441 :: 		write_tca9535( IOEXPANDER_DEVICE_ID6, TCA9535_OUTPUT_PORT0, LED_ALL_ON  )
	MOVLW      12
	MOVWF      FARG_write_tca9535_device_address+0
	MOVLW      2
	MOVWF      FARG_write_tca9535_command_byte+0
	CLRF       FARG_write_tca9535_w_data+0
	CALL       _write_tca9535+0
;ThrottleMonitor2.mbas,442 :: 		end if  end if  end if  end if
L__display_rpm_reverse212:
L__display_rpm_reverse209:
L__display_rpm_reverse206:
L__display_rpm_reverse203:
;ThrottleMonitor2.mbas,443 :: 		end sub
L_end_display_rpm_reverse:
	RETURN
; end of _display_rpm_reverse

_display_front_brake:

;ThrottleMonitor2.mbas,450 :: 		sub procedure display_front_brake(dim position as byte)
;ThrottleMonitor2.mbas,451 :: 		write_tca9535( IOEXPANDER_DEVICE_ID1, TCA9535_OUTPUT_PORT1, decode_barcode_backword(position) )
	MOVF       FARG_display_front_brake_position+0, 0
	MOVWF      FARG_decode_barcode_backword_level+0
	CALL       _decode_barcode_backword+0
	MOVF       R0, 0
	MOVWF      FARG_write_tca9535_w_data+0
	MOVLW      2
	MOVWF      FARG_write_tca9535_device_address+0
	MOVLW      3
	MOVWF      FARG_write_tca9535_command_byte+0
	CALL       _write_tca9535+0
;ThrottleMonitor2.mbas,452 :: 		end sub
L_end_display_front_brake:
	RETURN
; end of _display_front_brake

_display_rear_brake:

;ThrottleMonitor2.mbas,459 :: 		sub procedure display_rear_brake(dim position as byte)
;ThrottleMonitor2.mbas,460 :: 		write_tca9535( IOEXPANDER_DEVICE_ID6, TCA9535_OUTPUT_PORT1, decode_barcode_backword(position) )
	MOVF       FARG_display_rear_brake_position+0, 0
	MOVWF      FARG_decode_barcode_backword_level+0
	CALL       _decode_barcode_backword+0
	MOVF       R0, 0
	MOVWF      FARG_write_tca9535_w_data+0
	MOVLW      12
	MOVWF      FARG_write_tca9535_device_address+0
	MOVLW      3
	MOVWF      FARG_write_tca9535_command_byte+0
	CALL       _write_tca9535+0
;ThrottleMonitor2.mbas,461 :: 		end sub
L_end_display_rear_brake:
	RETURN
; end of _display_rear_brake

_display_speed:

;ThrottleMonitor2.mbas,472 :: 		dim digit3_maskpattern as byte
;ThrottleMonitor2.mbas,474 :: 		digit3 = number mod 10
	MOVLW      10
	MOVWF      R4
	MOVF       FARG_display_speed_number+0, 0
	MOVWF      R0
	CALL       _Div_8x8_U+0
	MOVF       R8, 0
	MOVWF      R0
	MOVF       R0, 0
	MOVWF      display_speed_digit3+0
;ThrottleMonitor2.mbas,475 :: 		number = number / 10
	MOVLW      10
	MOVWF      R4
	MOVF       FARG_display_speed_number+0, 0
	MOVWF      R0
	CALL       _Div_8x8_U+0
	MOVF       R0, 0
	MOVWF      FLOC__display_speed+0
	MOVF       FLOC__display_speed+0, 0
	MOVWF      FARG_display_speed_number+0
;ThrottleMonitor2.mbas,476 :: 		digit2 = number mod 10
	MOVLW      10
	MOVWF      R4
	MOVF       FLOC__display_speed+0, 0
	MOVWF      R0
	CALL       _Div_8x8_U+0
	MOVF       R8, 0
	MOVWF      R0
	MOVF       R0, 0
	MOVWF      display_speed_digit2+0
;ThrottleMonitor2.mbas,477 :: 		number = number / 10
	MOVLW      10
	MOVWF      R4
	MOVF       FLOC__display_speed+0, 0
	MOVWF      R0
	CALL       _Div_8x8_U+0
	MOVF       R0, 0
	MOVWF      FARG_display_speed_number+0
;ThrottleMonitor2.mbas,478 :: 		digit1 = number mod 10
	MOVLW      10
	MOVWF      R4
	CALL       _Div_8x8_U+0
	MOVF       R8, 0
	MOVWF      R0
;ThrottleMonitor2.mbas,480 :: 		digit1_maskpattern = decode_number( digit1 )
	MOVF       R0, 0
	MOVWF      FARG_decode_number_number+0
	CALL       _decode_number+0
	MOVF       R0, 0
	MOVWF      display_speed_digit1_maskpattern+0
;ThrottleMonitor2.mbas,481 :: 		digit2_maskpattern = decode_number( digit2 )
	MOVF       display_speed_digit2+0, 0
	MOVWF      FARG_decode_number_number+0
	CALL       _decode_number+0
	MOVF       R0, 0
	MOVWF      display_speed_digit2_maskpattern+0
;ThrottleMonitor2.mbas,482 :: 		digit3_maskpattern = decode_number( digit3 )
	MOVF       display_speed_digit3+0, 0
	MOVWF      FARG_decode_number_number+0
	CALL       _decode_number+0
	MOVF       R0, 0
	MOVWF      display_speed_digit3_maskpattern+0
;ThrottleMonitor2.mbas,483 :: 		if digit1_maskpattern = DIGIT_MASK_0 then
	MOVF       display_speed_digit1_maskpattern+0, 0
	XORLW      72
	BTFSS      STATUS+0, 2
	GOTO       L__display_speed217
;ThrottleMonitor2.mbas,484 :: 		digit1_maskpattern = DIGIT_MASK_NON
	MOVLW      255
	MOVWF      display_speed_digit1_maskpattern+0
;ThrottleMonitor2.mbas,485 :: 		if digit2_maskpattern = DIGIT_MASK_0 then
	MOVF       display_speed_digit2_maskpattern+0, 0
	XORLW      72
	BTFSS      STATUS+0, 2
	GOTO       L__display_speed220
;ThrottleMonitor2.mbas,486 :: 		digit2_maskpattern = DIGIT_MASK_NON
	MOVLW      255
	MOVWF      display_speed_digit2_maskpattern+0
L__display_speed220:
;ThrottleMonitor2.mbas,487 :: 		end if
L__display_speed217:
;ThrottleMonitor2.mbas,490 :: 		display_char( 1, digit1_maskpattern )
	MOVLW      1
	MOVWF      FARG_display_char_digit+0
	MOVF       display_speed_digit1_maskpattern+0, 0
	MOVWF      FARG_display_char_char_mask+0
	CALL       _display_char+0
;ThrottleMonitor2.mbas,491 :: 		display_char( 2, digit2_maskpattern )
	MOVLW      2
	MOVWF      FARG_display_char_digit+0
	MOVF       display_speed_digit2_maskpattern+0, 0
	MOVWF      FARG_display_char_char_mask+0
	CALL       _display_char+0
;ThrottleMonitor2.mbas,492 :: 		display_char( 3, digit3_maskpattern )
	MOVLW      3
	MOVWF      FARG_display_char_digit+0
	MOVF       display_speed_digit3_maskpattern+0, 0
	MOVWF      FARG_display_char_char_mask+0
	CALL       _display_char+0
;ThrottleMonitor2.mbas,493 :: 		end sub
L_end_display_speed:
	RETURN
; end of _display_speed

_display_word:

;ThrottleMonitor2.mbas,504 :: 		dim digit3_maskpattern as byte
;ThrottleMonitor2.mbas,506 :: 		digit3 = number mod 10
	MOVLW      10
	MOVWF      R4
	CLRF       R5
	MOVF       FARG_display_word_number+0, 0
	MOVWF      R0
	MOVF       FARG_display_word_number+1, 0
	MOVWF      R1
	CALL       _Div_16x16_U+0
	MOVF       R8, 0
	MOVWF      R0
	MOVF       R9, 0
	MOVWF      R1
	MOVF       R0, 0
	MOVWF      display_word_digit3+0
;ThrottleMonitor2.mbas,507 :: 		number = number / 10
	MOVLW      10
	MOVWF      R4
	CLRF       R5
	MOVF       FARG_display_word_number+0, 0
	MOVWF      R0
	MOVF       FARG_display_word_number+1, 0
	MOVWF      R1
	CALL       _Div_16x16_U+0
	MOVF       R0, 0
	MOVWF      FLOC__display_word+0
	MOVF       R1, 0
	MOVWF      FLOC__display_word+1
	MOVF       FLOC__display_word+0, 0
	MOVWF      FARG_display_word_number+0
	MOVF       FLOC__display_word+1, 0
	MOVWF      FARG_display_word_number+1
;ThrottleMonitor2.mbas,508 :: 		digit2 = number mod 10
	MOVLW      10
	MOVWF      R4
	CLRF       R5
	MOVF       FLOC__display_word+0, 0
	MOVWF      R0
	MOVF       FLOC__display_word+1, 0
	MOVWF      R1
	CALL       _Div_16x16_U+0
	MOVF       R8, 0
	MOVWF      R0
	MOVF       R9, 0
	MOVWF      R1
	MOVF       R0, 0
	MOVWF      display_word_digit2+0
;ThrottleMonitor2.mbas,509 :: 		number = number / 10
	MOVLW      10
	MOVWF      R4
	CLRF       R5
	MOVF       FLOC__display_word+0, 0
	MOVWF      R0
	MOVF       FLOC__display_word+1, 0
	MOVWF      R1
	CALL       _Div_16x16_U+0
	MOVF       R0, 0
	MOVWF      FARG_display_word_number+0
	MOVF       R1, 0
	MOVWF      FARG_display_word_number+1
;ThrottleMonitor2.mbas,510 :: 		digit1 = number mod 10
	MOVLW      10
	MOVWF      R4
	CLRF       R5
	CALL       _Div_16x16_U+0
	MOVF       R8, 0
	MOVWF      R0
	MOVF       R9, 0
	MOVWF      R1
;ThrottleMonitor2.mbas,512 :: 		digit1_maskpattern = decode_number( digit1 )
	MOVF       R0, 0
	MOVWF      FARG_decode_number_number+0
	CALL       _decode_number+0
	MOVF       R0, 0
	MOVWF      display_word_digit1_maskpattern+0
;ThrottleMonitor2.mbas,513 :: 		digit2_maskpattern = decode_number( digit2 )
	MOVF       display_word_digit2+0, 0
	MOVWF      FARG_decode_number_number+0
	CALL       _decode_number+0
	MOVF       R0, 0
	MOVWF      display_word_digit2_maskpattern+0
;ThrottleMonitor2.mbas,514 :: 		digit3_maskpattern = decode_number( digit3 )
	MOVF       display_word_digit3+0, 0
	MOVWF      FARG_decode_number_number+0
	CALL       _decode_number+0
	MOVF       R0, 0
	MOVWF      display_word_digit3_maskpattern+0
;ThrottleMonitor2.mbas,516 :: 		display_char( 1, digit1_maskpattern )
	MOVLW      1
	MOVWF      FARG_display_char_digit+0
	MOVF       display_word_digit1_maskpattern+0, 0
	MOVWF      FARG_display_char_char_mask+0
	CALL       _display_char+0
;ThrottleMonitor2.mbas,517 :: 		display_char( 2, digit2_maskpattern )
	MOVLW      2
	MOVWF      FARG_display_char_digit+0
	MOVF       display_word_digit2_maskpattern+0, 0
	MOVWF      FARG_display_char_char_mask+0
	CALL       _display_char+0
;ThrottleMonitor2.mbas,518 :: 		display_char( 3, digit3_maskpattern )
	MOVLW      3
	MOVWF      FARG_display_char_digit+0
	MOVF       display_word_digit3_maskpattern+0, 0
	MOVWF      FARG_display_char_char_mask+0
	CALL       _display_char+0
;ThrottleMonitor2.mbas,519 :: 		end sub
L_end_display_word:
	RETURN
; end of _display_word

_display_gear_position:

;ThrottleMonitor2.mbas,526 :: 		dim ratio as longword
;ThrottleMonitor2.mbas,528 :: 		if speed_kph = 0 then
	MOVF       FARG_display_gear_position_speed_kph+0, 0
	XORLW      0
	BTFSS      STATUS+0, 2
	GOTO       L__display_gear_position225
;ThrottleMonitor2.mbas,529 :: 		display_char( 4, DIGIT_MASK_0 )
	MOVLW      4
	MOVWF      FARG_display_char_digit+0
	MOVLW      72
	MOVWF      FARG_display_char_char_mask+0
	CALL       _display_char+0
;ThrottleMonitor2.mbas,530 :: 		exit
	GOTO       L_end__display_gear_position
L__display_gear_position225:
;ThrottleMonitor2.mbas,532 :: 		ratio = (rpm * 60 * TIRE_CIRCUMFERENCE_CB125R) / speed_kph
	MOVF       FARG_display_gear_position_rpm+0, 0
	MOVWF      R0
	MOVF       FARG_display_gear_position_rpm+1, 0
	MOVWF      R1
	MOVF       FARG_display_gear_position_rpm+2, 0
	MOVWF      R2
	MOVF       FARG_display_gear_position_rpm+3, 0
	MOVWF      R3
	MOVLW      60
	MOVWF      R4
	CLRF       R5
	CLRF       R6
	CLRF       R7
	CALL       _Mul_32x32_U+0
	MOVLW      130
	MOVWF      R4
	MOVLW      7
	MOVWF      R5
	CLRF       R6
	CLRF       R7
	CALL       _Mul_32x32_U+0
	MOVF       FARG_display_gear_position_speed_kph+0, 0
	MOVWF      R4
	CLRF       R5
	CLRF       R6
	CLRF       R7
	CALL       _Div_32x32_U+0
	MOVF       R0, 0
	MOVWF      display_gear_position_ratio+0
	MOVF       R1, 0
	MOVWF      display_gear_position_ratio+1
	MOVF       R2, 0
	MOVWF      display_gear_position_ratio+2
	MOVF       R3, 0
	MOVWF      display_gear_position_ratio+3
;ThrottleMonitor2.mbas,533 :: 		if ratio < GEAR_RATIO_CB125R_6 then
	MOVLW      0
	SUBWF      R3, 0
	BTFSS      STATUS+0, 2
	GOTO       L__display_gear_position429
	MOVLW      146
	SUBWF      R2, 0
	BTFSS      STATUS+0, 2
	GOTO       L__display_gear_position429
	MOVLW      223
	SUBWF      R1, 0
	BTFSS      STATUS+0, 2
	GOTO       L__display_gear_position429
	MOVLW      208
	SUBWF      R0, 0
L__display_gear_position429:
	BTFSC      STATUS+0, 0
	GOTO       L__display_gear_position228
;ThrottleMonitor2.mbas,534 :: 		display_char( 4, DIGIT_MASK_6 )
	MOVLW      4
	MOVWF      FARG_display_char_digit+0
	MOVLW      10
	MOVWF      FARG_display_char_char_mask+0
	CALL       _display_char+0
;ThrottleMonitor2.mbas,535 :: 		exit
	GOTO       L_end__display_gear_position
L__display_gear_position228:
;ThrottleMonitor2.mbas,537 :: 		if ratio < GEAR_RATIO_CB125R_5 then
	MOVLW      0
	SUBWF      display_gear_position_ratio+3, 0
	BTFSS      STATUS+0, 2
	GOTO       L__display_gear_position430
	MOVLW      165
	SUBWF      display_gear_position_ratio+2, 0
	BTFSS      STATUS+0, 2
	GOTO       L__display_gear_position430
	MOVLW      166
	SUBWF      display_gear_position_ratio+1, 0
	BTFSS      STATUS+0, 2
	GOTO       L__display_gear_position430
	MOVLW      185
	SUBWF      display_gear_position_ratio+0, 0
L__display_gear_position430:
	BTFSC      STATUS+0, 0
	GOTO       L__display_gear_position231
;ThrottleMonitor2.mbas,538 :: 		display_char( 4, DIGIT_MASK_5 )
	MOVLW      4
	MOVWF      FARG_display_char_digit+0
	MOVLW      11
	MOVWF      FARG_display_char_char_mask+0
	CALL       _display_char+0
;ThrottleMonitor2.mbas,539 :: 		exit
	GOTO       L_end__display_gear_position
L__display_gear_position231:
;ThrottleMonitor2.mbas,541 :: 		if ratio < GEAR_RATIO_CB125R_4 then
	MOVLW      0
	SUBWF      display_gear_position_ratio+3, 0
	BTFSS      STATUS+0, 2
	GOTO       L__display_gear_position431
	MOVLW      186
	SUBWF      display_gear_position_ratio+2, 0
	BTFSS      STATUS+0, 2
	GOTO       L__display_gear_position431
	MOVLW      167
	SUBWF      display_gear_position_ratio+1, 0
	BTFSS      STATUS+0, 2
	GOTO       L__display_gear_position431
	MOVLW      241
	SUBWF      display_gear_position_ratio+0, 0
L__display_gear_position431:
	BTFSC      STATUS+0, 0
	GOTO       L__display_gear_position234
;ThrottleMonitor2.mbas,542 :: 		display_char( 4, DIGIT_MASK_4 )
	MOVLW      4
	MOVWF      FARG_display_char_digit+0
	MOVLW      45
	MOVWF      FARG_display_char_char_mask+0
	CALL       _display_char+0
;ThrottleMonitor2.mbas,543 :: 		exit
	GOTO       L_end__display_gear_position
L__display_gear_position234:
;ThrottleMonitor2.mbas,545 :: 		if ratio < GEAR_RATIO_CB125R_3 then
	MOVLW      0
	SUBWF      display_gear_position_ratio+3, 0
	BTFSS      STATUS+0, 2
	GOTO       L__display_gear_position432
	MOVLW      230
	SUBWF      display_gear_position_ratio+2, 0
	BTFSS      STATUS+0, 2
	GOTO       L__display_gear_position432
	MOVLW      187
	SUBWF      display_gear_position_ratio+1, 0
	BTFSS      STATUS+0, 2
	GOTO       L__display_gear_position432
	MOVLW      246
	SUBWF      display_gear_position_ratio+0, 0
L__display_gear_position432:
	BTFSC      STATUS+0, 0
	GOTO       L__display_gear_position237
;ThrottleMonitor2.mbas,546 :: 		display_char( 4, DIGIT_MASK_3 )
	MOVLW      4
	MOVWF      FARG_display_char_digit+0
	MOVLW      137
	MOVWF      FARG_display_char_char_mask+0
	CALL       _display_char+0
;ThrottleMonitor2.mbas,547 :: 		exit
	GOTO       L_end__display_gear_position
L__display_gear_position237:
;ThrottleMonitor2.mbas,549 :: 		if ratio < GEAR_RATIO_CB125R_2 then
	MOVLW      1
	SUBWF      display_gear_position_ratio+3, 0
	BTFSS      STATUS+0, 2
	GOTO       L__display_gear_position433
	MOVLW      52
	SUBWF      display_gear_position_ratio+2, 0
	BTFSS      STATUS+0, 2
	GOTO       L__display_gear_position433
	MOVLW      221
	SUBWF      display_gear_position_ratio+1, 0
	BTFSS      STATUS+0, 2
	GOTO       L__display_gear_position433
	MOVLW      152
	SUBWF      display_gear_position_ratio+0, 0
L__display_gear_position433:
	BTFSC      STATUS+0, 0
	GOTO       L__display_gear_position240
;ThrottleMonitor2.mbas,550 :: 		display_char( 4, DIGIT_MASK_2 )
	MOVLW      4
	MOVWF      FARG_display_char_digit+0
	MOVLW      152
	MOVWF      FARG_display_char_char_mask+0
	CALL       _display_char+0
;ThrottleMonitor2.mbas,551 :: 		exit
	GOTO       L_end__display_gear_position
L__display_gear_position240:
;ThrottleMonitor2.mbas,553 :: 		if ratio < GEAR_RATIO_CB125R_1 then
	MOVLW      2
	SUBWF      display_gear_position_ratio+3, 0
	BTFSS      STATUS+0, 2
	GOTO       L__display_gear_position434
	MOVLW      37
	SUBWF      display_gear_position_ratio+2, 0
	BTFSS      STATUS+0, 2
	GOTO       L__display_gear_position434
	MOVLW      159
	SUBWF      display_gear_position_ratio+1, 0
	BTFSS      STATUS+0, 2
	GOTO       L__display_gear_position434
	MOVLW      244
	SUBWF      display_gear_position_ratio+0, 0
L__display_gear_position434:
	BTFSC      STATUS+0, 0
	GOTO       L__display_gear_position243
;ThrottleMonitor2.mbas,554 :: 		display_char( 4, DIGIT_MASK_1 )
	MOVLW      4
	MOVWF      FARG_display_char_digit+0
	MOVLW      237
	MOVWF      FARG_display_char_char_mask+0
	CALL       _display_char+0
	GOTO       L__display_gear_position244
;ThrottleMonitor2.mbas,555 :: 		else
L__display_gear_position243:
;ThrottleMonitor2.mbas,556 :: 		display_char( 4, DIGIT_MASK_0 )
	MOVLW      4
	MOVWF      FARG_display_char_digit+0
	MOVLW      72
	MOVWF      FARG_display_char_char_mask+0
	CALL       _display_char+0
;ThrottleMonitor2.mbas,557 :: 		end if
L__display_gear_position244:
;ThrottleMonitor2.mbas,558 :: 		end sub
L_end__display_gear_position:
L_end_display_gear_position:
	RETURN
; end of _display_gear_position

_ioexpander_tca9535_initialize:

;ThrottleMonitor2.mbas,563 :: 		sub procedure ioexpander_tca9535_initialize()
;ThrottleMonitor2.mbas,564 :: 		write_tca9535(IOEXPANDER_DEVICE_ID0, TCA9535_CONFIGURATION_PORT0,TCA9535_CONFIGURATION_OUTPUT)
	CLRF       FARG_write_tca9535_device_address+0
	MOVLW      6
	MOVWF      FARG_write_tca9535_command_byte+0
	CLRF       FARG_write_tca9535_w_data+0
	CALL       _write_tca9535+0
;ThrottleMonitor2.mbas,565 :: 		write_tca9535(IOEXPANDER_DEVICE_ID0, TCA9535_CONFIGURATION_PORT1,TCA9535_CONFIGURATION_OUTPUT)
	CLRF       FARG_write_tca9535_device_address+0
	MOVLW      7
	MOVWF      FARG_write_tca9535_command_byte+0
	CLRF       FARG_write_tca9535_w_data+0
	CALL       _write_tca9535+0
;ThrottleMonitor2.mbas,566 :: 		write_tca9535(IOEXPANDER_DEVICE_ID1, TCA9535_CONFIGURATION_PORT0,TCA9535_CONFIGURATION_OUTPUT)
	MOVLW      2
	MOVWF      FARG_write_tca9535_device_address+0
	MOVLW      6
	MOVWF      FARG_write_tca9535_command_byte+0
	CLRF       FARG_write_tca9535_w_data+0
	CALL       _write_tca9535+0
;ThrottleMonitor2.mbas,567 :: 		write_tca9535(IOEXPANDER_DEVICE_ID1, TCA9535_CONFIGURATION_PORT1,TCA9535_CONFIGURATION_OUTPUT)
	MOVLW      2
	MOVWF      FARG_write_tca9535_device_address+0
	MOVLW      7
	MOVWF      FARG_write_tca9535_command_byte+0
	CLRF       FARG_write_tca9535_w_data+0
	CALL       _write_tca9535+0
;ThrottleMonitor2.mbas,568 :: 		write_tca9535(IOEXPANDER_DEVICE_ID2, TCA9535_CONFIGURATION_PORT0,TCA9535_CONFIGURATION_OUTPUT)
	MOVLW      4
	MOVWF      FARG_write_tca9535_device_address+0
	MOVLW      6
	MOVWF      FARG_write_tca9535_command_byte+0
	CLRF       FARG_write_tca9535_w_data+0
	CALL       _write_tca9535+0
;ThrottleMonitor2.mbas,569 :: 		write_tca9535(IOEXPANDER_DEVICE_ID2, TCA9535_CONFIGURATION_PORT1,TCA9535_CONFIGURATION_OUTPUT)
	MOVLW      4
	MOVWF      FARG_write_tca9535_device_address+0
	MOVLW      7
	MOVWF      FARG_write_tca9535_command_byte+0
	CLRF       FARG_write_tca9535_w_data+0
	CALL       _write_tca9535+0
;ThrottleMonitor2.mbas,570 :: 		write_tca9535(IOEXPANDER_DEVICE_ID3, TCA9535_CONFIGURATION_PORT0,TCA9535_CONFIGURATION_OUTPUT)
	MOVLW      6
	MOVWF      FARG_write_tca9535_device_address+0
	MOVLW      6
	MOVWF      FARG_write_tca9535_command_byte+0
	CLRF       FARG_write_tca9535_w_data+0
	CALL       _write_tca9535+0
;ThrottleMonitor2.mbas,571 :: 		write_tca9535(IOEXPANDER_DEVICE_ID3, TCA9535_CONFIGURATION_PORT1,TCA9535_CONFIGURATION_OUTPUT)
	MOVLW      6
	MOVWF      FARG_write_tca9535_device_address+0
	MOVLW      7
	MOVWF      FARG_write_tca9535_command_byte+0
	CLRF       FARG_write_tca9535_w_data+0
	CALL       _write_tca9535+0
;ThrottleMonitor2.mbas,572 :: 		write_tca9535(IOEXPANDER_DEVICE_ID4, TCA9535_CONFIGURATION_PORT0,TCA9535_CONFIGURATION_OUTPUT)
	MOVLW      8
	MOVWF      FARG_write_tca9535_device_address+0
	MOVLW      6
	MOVWF      FARG_write_tca9535_command_byte+0
	CLRF       FARG_write_tca9535_w_data+0
	CALL       _write_tca9535+0
;ThrottleMonitor2.mbas,573 :: 		write_tca9535(IOEXPANDER_DEVICE_ID4, TCA9535_CONFIGURATION_PORT1,TCA9535_CONFIGURATION_OUTPUT)
	MOVLW      8
	MOVWF      FARG_write_tca9535_device_address+0
	MOVLW      7
	MOVWF      FARG_write_tca9535_command_byte+0
	CLRF       FARG_write_tca9535_w_data+0
	CALL       _write_tca9535+0
;ThrottleMonitor2.mbas,574 :: 		write_tca9535(IOEXPANDER_DEVICE_ID5, TCA9535_CONFIGURATION_PORT0,TCA9535_CONFIGURATION_OUTPUT)
	MOVLW      10
	MOVWF      FARG_write_tca9535_device_address+0
	MOVLW      6
	MOVWF      FARG_write_tca9535_command_byte+0
	CLRF       FARG_write_tca9535_w_data+0
	CALL       _write_tca9535+0
;ThrottleMonitor2.mbas,575 :: 		write_tca9535(IOEXPANDER_DEVICE_ID5, TCA9535_CONFIGURATION_PORT1,TCA9535_CONFIGURATION_OUTPUT)
	MOVLW      10
	MOVWF      FARG_write_tca9535_device_address+0
	MOVLW      7
	MOVWF      FARG_write_tca9535_command_byte+0
	CLRF       FARG_write_tca9535_w_data+0
	CALL       _write_tca9535+0
;ThrottleMonitor2.mbas,576 :: 		write_tca9535(IOEXPANDER_DEVICE_ID6, TCA9535_CONFIGURATION_PORT0,TCA9535_CONFIGURATION_OUTPUT)
	MOVLW      12
	MOVWF      FARG_write_tca9535_device_address+0
	MOVLW      6
	MOVWF      FARG_write_tca9535_command_byte+0
	CLRF       FARG_write_tca9535_w_data+0
	CALL       _write_tca9535+0
;ThrottleMonitor2.mbas,577 :: 		write_tca9535(IOEXPANDER_DEVICE_ID6, TCA9535_CONFIGURATION_PORT1,TCA9535_CONFIGURATION_OUTPUT)
	MOVLW      12
	MOVWF      FARG_write_tca9535_device_address+0
	MOVLW      7
	MOVWF      FARG_write_tca9535_command_byte+0
	CLRF       FARG_write_tca9535_w_data+0
	CALL       _write_tca9535+0
;ThrottleMonitor2.mbas,579 :: 		write_tca9535(IOEXPANDER_DEVICE_ID0, TCA9535_OUTPUT_PORT0, LED_ALL_OFF)
	CLRF       FARG_write_tca9535_device_address+0
	MOVLW      2
	MOVWF      FARG_write_tca9535_command_byte+0
	MOVLW      255
	MOVWF      FARG_write_tca9535_w_data+0
	CALL       _write_tca9535+0
;ThrottleMonitor2.mbas,580 :: 		write_tca9535(IOEXPANDER_DEVICE_ID0, TCA9535_OUTPUT_PORT1, LED_ALL_OFF)
	CLRF       FARG_write_tca9535_device_address+0
	MOVLW      3
	MOVWF      FARG_write_tca9535_command_byte+0
	MOVLW      255
	MOVWF      FARG_write_tca9535_w_data+0
	CALL       _write_tca9535+0
;ThrottleMonitor2.mbas,581 :: 		write_tca9535(IOEXPANDER_DEVICE_ID1, TCA9535_OUTPUT_PORT0, LED_ALL_OFF)
	MOVLW      2
	MOVWF      FARG_write_tca9535_device_address+0
	MOVLW      2
	MOVWF      FARG_write_tca9535_command_byte+0
	MOVLW      255
	MOVWF      FARG_write_tca9535_w_data+0
	CALL       _write_tca9535+0
;ThrottleMonitor2.mbas,582 :: 		write_tca9535(IOEXPANDER_DEVICE_ID1, TCA9535_OUTPUT_PORT1, LED_ALL_OFF)
	MOVLW      2
	MOVWF      FARG_write_tca9535_device_address+0
	MOVLW      3
	MOVWF      FARG_write_tca9535_command_byte+0
	MOVLW      255
	MOVWF      FARG_write_tca9535_w_data+0
	CALL       _write_tca9535+0
;ThrottleMonitor2.mbas,583 :: 		write_tca9535(IOEXPANDER_DEVICE_ID2, TCA9535_OUTPUT_PORT0, LED_ALL_OFF)
	MOVLW      4
	MOVWF      FARG_write_tca9535_device_address+0
	MOVLW      2
	MOVWF      FARG_write_tca9535_command_byte+0
	MOVLW      255
	MOVWF      FARG_write_tca9535_w_data+0
	CALL       _write_tca9535+0
;ThrottleMonitor2.mbas,584 :: 		write_tca9535(IOEXPANDER_DEVICE_ID2, TCA9535_OUTPUT_PORT1, LED_ALL_OFF)
	MOVLW      4
	MOVWF      FARG_write_tca9535_device_address+0
	MOVLW      3
	MOVWF      FARG_write_tca9535_command_byte+0
	MOVLW      255
	MOVWF      FARG_write_tca9535_w_data+0
	CALL       _write_tca9535+0
;ThrottleMonitor2.mbas,585 :: 		write_tca9535(IOEXPANDER_DEVICE_ID3, TCA9535_OUTPUT_PORT0, LED_ALL_OFF)
	MOVLW      6
	MOVWF      FARG_write_tca9535_device_address+0
	MOVLW      2
	MOVWF      FARG_write_tca9535_command_byte+0
	MOVLW      255
	MOVWF      FARG_write_tca9535_w_data+0
	CALL       _write_tca9535+0
;ThrottleMonitor2.mbas,586 :: 		write_tca9535(IOEXPANDER_DEVICE_ID3, TCA9535_OUTPUT_PORT1, LED_ALL_OFF)
	MOVLW      6
	MOVWF      FARG_write_tca9535_device_address+0
	MOVLW      3
	MOVWF      FARG_write_tca9535_command_byte+0
	MOVLW      255
	MOVWF      FARG_write_tca9535_w_data+0
	CALL       _write_tca9535+0
;ThrottleMonitor2.mbas,587 :: 		write_tca9535(IOEXPANDER_DEVICE_ID4, TCA9535_OUTPUT_PORT0, LED_ALL_OFF)
	MOVLW      8
	MOVWF      FARG_write_tca9535_device_address+0
	MOVLW      2
	MOVWF      FARG_write_tca9535_command_byte+0
	MOVLW      255
	MOVWF      FARG_write_tca9535_w_data+0
	CALL       _write_tca9535+0
;ThrottleMonitor2.mbas,588 :: 		write_tca9535(IOEXPANDER_DEVICE_ID4, TCA9535_OUTPUT_PORT1, LED_ALL_OFF)
	MOVLW      8
	MOVWF      FARG_write_tca9535_device_address+0
	MOVLW      3
	MOVWF      FARG_write_tca9535_command_byte+0
	MOVLW      255
	MOVWF      FARG_write_tca9535_w_data+0
	CALL       _write_tca9535+0
;ThrottleMonitor2.mbas,589 :: 		write_tca9535(IOEXPANDER_DEVICE_ID5, TCA9535_OUTPUT_PORT0, LED_ALL_OFF)
	MOVLW      10
	MOVWF      FARG_write_tca9535_device_address+0
	MOVLW      2
	MOVWF      FARG_write_tca9535_command_byte+0
	MOVLW      255
	MOVWF      FARG_write_tca9535_w_data+0
	CALL       _write_tca9535+0
;ThrottleMonitor2.mbas,590 :: 		write_tca9535(IOEXPANDER_DEVICE_ID5, TCA9535_OUTPUT_PORT1, LED_ALL_OFF)
	MOVLW      10
	MOVWF      FARG_write_tca9535_device_address+0
	MOVLW      3
	MOVWF      FARG_write_tca9535_command_byte+0
	MOVLW      255
	MOVWF      FARG_write_tca9535_w_data+0
	CALL       _write_tca9535+0
;ThrottleMonitor2.mbas,591 :: 		write_tca9535(IOEXPANDER_DEVICE_ID6, TCA9535_OUTPUT_PORT0, LED_ALL_OFF)
	MOVLW      12
	MOVWF      FARG_write_tca9535_device_address+0
	MOVLW      2
	MOVWF      FARG_write_tca9535_command_byte+0
	MOVLW      255
	MOVWF      FARG_write_tca9535_w_data+0
	CALL       _write_tca9535+0
;ThrottleMonitor2.mbas,592 :: 		write_tca9535(IOEXPANDER_DEVICE_ID6, TCA9535_OUTPUT_PORT1, LED_ALL_OFF)
	MOVLW      12
	MOVWF      FARG_write_tca9535_device_address+0
	MOVLW      3
	MOVWF      FARG_write_tca9535_command_byte+0
	MOVLW      255
	MOVWF      FARG_write_tca9535_w_data+0
	CALL       _write_tca9535+0
;ThrottleMonitor2.mbas,593 :: 		end sub
L_end_ioexpander_tca9535_initialize:
	RETURN
; end of _ioexpander_tca9535_initialize

_segment_led_test:

;ThrottleMonitor2.mbas,598 :: 		sub procedure segment_led_test(dim pattern as byte)
;ThrottleMonitor2.mbas,599 :: 		display_char( 1, pattern )
	MOVLW      1
	MOVWF      FARG_display_char_digit+0
	MOVF       FARG_segment_led_test_pattern+0, 0
	MOVWF      FARG_display_char_char_mask+0
	CALL       _display_char+0
;ThrottleMonitor2.mbas,600 :: 		display_char( 2, pattern )
	MOVLW      2
	MOVWF      FARG_display_char_digit+0
	MOVF       FARG_segment_led_test_pattern+0, 0
	MOVWF      FARG_display_char_char_mask+0
	CALL       _display_char+0
;ThrottleMonitor2.mbas,601 :: 		display_char( 3, pattern )
	MOVLW      3
	MOVWF      FARG_display_char_digit+0
	MOVF       FARG_segment_led_test_pattern+0, 0
	MOVWF      FARG_display_char_char_mask+0
	CALL       _display_char+0
;ThrottleMonitor2.mbas,602 :: 		display_char( 4, pattern )
	MOVLW      4
	MOVWF      FARG_display_char_digit+0
	MOVF       FARG_segment_led_test_pattern+0, 0
	MOVWF      FARG_display_char_char_mask+0
	CALL       _display_char+0
;ThrottleMonitor2.mbas,603 :: 		end sub
L_end_segment_led_test:
	RETURN
; end of _segment_led_test

_display_startup:

;ThrottleMonitor2.mbas,609 :: 		dim num as byte
;ThrottleMonitor2.mbas,611 :: 		segment_led_test( SEGMENT_A )
	MOVLW      251
	MOVWF      FARG_segment_led_test_pattern+0
	CALL       _segment_led_test+0
;ThrottleMonitor2.mbas,612 :: 		delay_ms(70)
	MOVLW      3
	MOVWF      R11
	MOVLW      216
	MOVWF      R12
	MOVLW      65
	MOVWF      R13
L__display_startup248:
	DECFSZ     R13, 1
	GOTO       L__display_startup248
	DECFSZ     R12, 1
	GOTO       L__display_startup248
	DECFSZ     R11, 1
	GOTO       L__display_startup248
	NOP
	NOP
;ThrottleMonitor2.mbas,613 :: 		segment_led_test( SEGMENT_B )
	MOVLW      253
	MOVWF      FARG_segment_led_test_pattern+0
	CALL       _segment_led_test+0
;ThrottleMonitor2.mbas,614 :: 		delay_ms(70)
	MOVLW      3
	MOVWF      R11
	MOVLW      216
	MOVWF      R12
	MOVLW      65
	MOVWF      R13
L__display_startup249:
	DECFSZ     R13, 1
	GOTO       L__display_startup249
	DECFSZ     R12, 1
	GOTO       L__display_startup249
	DECFSZ     R11, 1
	GOTO       L__display_startup249
	NOP
	NOP
;ThrottleMonitor2.mbas,615 :: 		segment_led_test( SEGMENT_C )
	MOVLW      239
	MOVWF      FARG_segment_led_test_pattern+0
	CALL       _segment_led_test+0
;ThrottleMonitor2.mbas,616 :: 		delay_ms(70)
	MOVLW      3
	MOVWF      R11
	MOVLW      216
	MOVWF      R12
	MOVLW      65
	MOVWF      R13
L__display_startup250:
	DECFSZ     R13, 1
	GOTO       L__display_startup250
	DECFSZ     R12, 1
	GOTO       L__display_startup250
	DECFSZ     R11, 1
	GOTO       L__display_startup250
	NOP
	NOP
;ThrottleMonitor2.mbas,617 :: 		segment_led_test( SEGMENT_D )
	MOVLW      223
	MOVWF      FARG_segment_led_test_pattern+0
	CALL       _segment_led_test+0
;ThrottleMonitor2.mbas,618 :: 		delay_ms(70)
	MOVLW      3
	MOVWF      R11
	MOVLW      216
	MOVWF      R12
	MOVLW      65
	MOVWF      R13
L__display_startup251:
	DECFSZ     R13, 1
	GOTO       L__display_startup251
	DECFSZ     R12, 1
	GOTO       L__display_startup251
	DECFSZ     R11, 1
	GOTO       L__display_startup251
	NOP
	NOP
;ThrottleMonitor2.mbas,619 :: 		segment_led_test( SEGMENT_E )
	MOVLW      254
	MOVWF      FARG_segment_led_test_pattern+0
	CALL       _segment_led_test+0
;ThrottleMonitor2.mbas,620 :: 		delay_ms(70)
	MOVLW      3
	MOVWF      R11
	MOVLW      216
	MOVWF      R12
	MOVLW      65
	MOVWF      R13
L__display_startup252:
	DECFSZ     R13, 1
	GOTO       L__display_startup252
	DECFSZ     R12, 1
	GOTO       L__display_startup252
	DECFSZ     R11, 1
	GOTO       L__display_startup252
	NOP
	NOP
;ThrottleMonitor2.mbas,621 :: 		segment_led_test( SEGMENT_F )
	MOVLW      127
	MOVWF      FARG_segment_led_test_pattern+0
	CALL       _segment_led_test+0
;ThrottleMonitor2.mbas,622 :: 		delay_ms(70)
	MOVLW      3
	MOVWF      R11
	MOVLW      216
	MOVWF      R12
	MOVLW      65
	MOVWF      R13
L__display_startup253:
	DECFSZ     R13, 1
	GOTO       L__display_startup253
	DECFSZ     R12, 1
	GOTO       L__display_startup253
	DECFSZ     R11, 1
	GOTO       L__display_startup253
	NOP
	NOP
;ThrottleMonitor2.mbas,623 :: 		segment_led_test( SEGMENT_G )
	MOVLW      191
	MOVWF      FARG_segment_led_test_pattern+0
	CALL       _segment_led_test+0
;ThrottleMonitor2.mbas,624 :: 		delay_ms(70)
	MOVLW      3
	MOVWF      R11
	MOVLW      216
	MOVWF      R12
	MOVLW      65
	MOVWF      R13
L__display_startup254:
	DECFSZ     R13, 1
	GOTO       L__display_startup254
	DECFSZ     R12, 1
	GOTO       L__display_startup254
	DECFSZ     R11, 1
	GOTO       L__display_startup254
	NOP
	NOP
;ThrottleMonitor2.mbas,625 :: 		segment_led_test( SEGMENT_DP )
	MOVLW      247
	MOVWF      FARG_segment_led_test_pattern+0
	CALL       _segment_led_test+0
;ThrottleMonitor2.mbas,626 :: 		delay_ms(70)
	MOVLW      3
	MOVWF      R11
	MOVLW      216
	MOVWF      R12
	MOVLW      65
	MOVWF      R13
L__display_startup255:
	DECFSZ     R13, 1
	GOTO       L__display_startup255
	DECFSZ     R12, 1
	GOTO       L__display_startup255
	DECFSZ     R11, 1
	GOTO       L__display_startup255
	NOP
	NOP
;ThrottleMonitor2.mbas,627 :: 		segment_led_test( DIGIT_MASK_NON )
	MOVLW      255
	MOVWF      FARG_segment_led_test_pattern+0
	CALL       _segment_led_test+0
;ThrottleMonitor2.mbas,629 :: 		for num = 0 to 24
	CLRF       display_startup_num+0
L__display_startup257:
;ThrottleMonitor2.mbas,630 :: 		display_throttle( num )
	MOVF       display_startup_num+0, 0
	MOVWF      FARG_display_throttle_throttle_position+0
	CALL       _display_throttle+0
;ThrottleMonitor2.mbas,631 :: 		delay_ms(5)
	MOVLW      52
	MOVWF      R12
	MOVLW      241
	MOVWF      R13
L__display_startup261:
	DECFSZ     R13, 1
	GOTO       L__display_startup261
	DECFSZ     R12, 1
	GOTO       L__display_startup261
	NOP
	NOP
;ThrottleMonitor2.mbas,632 :: 		next num
	MOVF       display_startup_num+0, 0
	XORLW      24
	BTFSC      STATUS+0, 2
	GOTO       L__display_startup260
	INCF       display_startup_num+0, 1
	GOTO       L__display_startup257
L__display_startup260:
;ThrottleMonitor2.mbas,633 :: 		delay_ms(50)
	MOVLW      3
	MOVWF      R11
	MOVLW      8
	MOVWF      R12
	MOVLW      119
	MOVWF      R13
L__display_startup262:
	DECFSZ     R13, 1
	GOTO       L__display_startup262
	DECFSZ     R12, 1
	GOTO       L__display_startup262
	DECFSZ     R11, 1
	GOTO       L__display_startup262
;ThrottleMonitor2.mbas,634 :: 		for num = 24 to 0 step -1
	MOVLW      24
	MOVWF      display_startup_num+0
L__display_startup264:
;ThrottleMonitor2.mbas,635 :: 		display_throttle( num )
	MOVF       display_startup_num+0, 0
	MOVWF      FARG_display_throttle_throttle_position+0
	CALL       _display_throttle+0
;ThrottleMonitor2.mbas,636 :: 		delay_ms(5)
	MOVLW      52
	MOVWF      R12
	MOVLW      241
	MOVWF      R13
L__display_startup268:
	DECFSZ     R13, 1
	GOTO       L__display_startup268
	DECFSZ     R12, 1
	GOTO       L__display_startup268
	NOP
	NOP
;ThrottleMonitor2.mbas,637 :: 		next num
	MOVF       display_startup_num+0, 0
	XORLW      0
	BTFSC      STATUS+0, 2
	GOTO       L__display_startup267
	MOVLW      255
	ADDWF      display_startup_num+0, 1
	GOTO       L__display_startup264
L__display_startup267:
;ThrottleMonitor2.mbas,639 :: 		for num = 0 to 8
	CLRF       display_startup_num+0
L__display_startup270:
;ThrottleMonitor2.mbas,640 :: 		display_front_brake( num )
	MOVF       display_startup_num+0, 0
	MOVWF      FARG_display_front_brake_position+0
	CALL       _display_front_brake+0
;ThrottleMonitor2.mbas,641 :: 		delay_ms(5)
	MOVLW      52
	MOVWF      R12
	MOVLW      241
	MOVWF      R13
L__display_startup274:
	DECFSZ     R13, 1
	GOTO       L__display_startup274
	DECFSZ     R12, 1
	GOTO       L__display_startup274
	NOP
	NOP
;ThrottleMonitor2.mbas,642 :: 		next num
	MOVF       display_startup_num+0, 0
	XORLW      8
	BTFSC      STATUS+0, 2
	GOTO       L__display_startup273
	INCF       display_startup_num+0, 1
	GOTO       L__display_startup270
L__display_startup273:
;ThrottleMonitor2.mbas,643 :: 		delay_ms(50)
	MOVLW      3
	MOVWF      R11
	MOVLW      8
	MOVWF      R12
	MOVLW      119
	MOVWF      R13
L__display_startup275:
	DECFSZ     R13, 1
	GOTO       L__display_startup275
	DECFSZ     R12, 1
	GOTO       L__display_startup275
	DECFSZ     R11, 1
	GOTO       L__display_startup275
;ThrottleMonitor2.mbas,644 :: 		for num = 8 to 0 step -1
	MOVLW      8
	MOVWF      display_startup_num+0
L__display_startup277:
;ThrottleMonitor2.mbas,645 :: 		display_front_brake( num )
	MOVF       display_startup_num+0, 0
	MOVWF      FARG_display_front_brake_position+0
	CALL       _display_front_brake+0
;ThrottleMonitor2.mbas,646 :: 		delay_ms(5)
	MOVLW      52
	MOVWF      R12
	MOVLW      241
	MOVWF      R13
L__display_startup281:
	DECFSZ     R13, 1
	GOTO       L__display_startup281
	DECFSZ     R12, 1
	GOTO       L__display_startup281
	NOP
	NOP
;ThrottleMonitor2.mbas,647 :: 		next num
	MOVF       display_startup_num+0, 0
	XORLW      0
	BTFSC      STATUS+0, 2
	GOTO       L__display_startup280
	MOVLW      255
	ADDWF      display_startup_num+0, 1
	GOTO       L__display_startup277
L__display_startup280:
;ThrottleMonitor2.mbas,649 :: 		for num = 0 to 8
	CLRF       display_startup_num+0
L__display_startup283:
;ThrottleMonitor2.mbas,650 :: 		display_rear_brake( num )
	MOVF       display_startup_num+0, 0
	MOVWF      FARG_display_rear_brake_position+0
	CALL       _display_rear_brake+0
;ThrottleMonitor2.mbas,651 :: 		delay_ms(5)
	MOVLW      52
	MOVWF      R12
	MOVLW      241
	MOVWF      R13
L__display_startup287:
	DECFSZ     R13, 1
	GOTO       L__display_startup287
	DECFSZ     R12, 1
	GOTO       L__display_startup287
	NOP
	NOP
;ThrottleMonitor2.mbas,652 :: 		next num
	MOVF       display_startup_num+0, 0
	XORLW      8
	BTFSC      STATUS+0, 2
	GOTO       L__display_startup286
	INCF       display_startup_num+0, 1
	GOTO       L__display_startup283
L__display_startup286:
;ThrottleMonitor2.mbas,653 :: 		delay_ms(50)
	MOVLW      3
	MOVWF      R11
	MOVLW      8
	MOVWF      R12
	MOVLW      119
	MOVWF      R13
L__display_startup288:
	DECFSZ     R13, 1
	GOTO       L__display_startup288
	DECFSZ     R12, 1
	GOTO       L__display_startup288
	DECFSZ     R11, 1
	GOTO       L__display_startup288
;ThrottleMonitor2.mbas,654 :: 		for num = 8 to 0 step -1
	MOVLW      8
	MOVWF      display_startup_num+0
L__display_startup290:
;ThrottleMonitor2.mbas,655 :: 		display_rear_brake( num )
	MOVF       display_startup_num+0, 0
	MOVWF      FARG_display_rear_brake_position+0
	CALL       _display_rear_brake+0
;ThrottleMonitor2.mbas,656 :: 		delay_ms(5)
	MOVLW      52
	MOVWF      R12
	MOVLW      241
	MOVWF      R13
L__display_startup294:
	DECFSZ     R13, 1
	GOTO       L__display_startup294
	DECFSZ     R12, 1
	GOTO       L__display_startup294
	NOP
	NOP
;ThrottleMonitor2.mbas,657 :: 		next num
	MOVF       display_startup_num+0, 0
	XORLW      0
	BTFSC      STATUS+0, 2
	GOTO       L__display_startup293
	MOVLW      255
	ADDWF      display_startup_num+0, 1
	GOTO       L__display_startup290
L__display_startup293:
;ThrottleMonitor2.mbas,659 :: 		for num = 0 to 40
	CLRF       display_startup_num+0
L__display_startup296:
;ThrottleMonitor2.mbas,660 :: 		display_rpm( num )
	MOVF       display_startup_num+0, 0
	MOVWF      FARG_display_rpm_rpm+0
	CALL       _display_rpm+0
;ThrottleMonitor2.mbas,661 :: 		delay_ms(5)
	MOVLW      52
	MOVWF      R12
	MOVLW      241
	MOVWF      R13
L__display_startup300:
	DECFSZ     R13, 1
	GOTO       L__display_startup300
	DECFSZ     R12, 1
	GOTO       L__display_startup300
	NOP
	NOP
;ThrottleMonitor2.mbas,662 :: 		next num
	MOVF       display_startup_num+0, 0
	XORLW      40
	BTFSC      STATUS+0, 2
	GOTO       L__display_startup299
	INCF       display_startup_num+0, 1
	GOTO       L__display_startup296
L__display_startup299:
;ThrottleMonitor2.mbas,663 :: 		delay_ms(50)
	MOVLW      3
	MOVWF      R11
	MOVLW      8
	MOVWF      R12
	MOVLW      119
	MOVWF      R13
L__display_startup301:
	DECFSZ     R13, 1
	GOTO       L__display_startup301
	DECFSZ     R12, 1
	GOTO       L__display_startup301
	DECFSZ     R11, 1
	GOTO       L__display_startup301
;ThrottleMonitor2.mbas,664 :: 		for num = 40 to 0 step -1
	MOVLW      40
	MOVWF      display_startup_num+0
L__display_startup303:
;ThrottleMonitor2.mbas,665 :: 		display_rpm( num )
	MOVF       display_startup_num+0, 0
	MOVWF      FARG_display_rpm_rpm+0
	CALL       _display_rpm+0
;ThrottleMonitor2.mbas,666 :: 		delay_ms(5)
	MOVLW      52
	MOVWF      R12
	MOVLW      241
	MOVWF      R13
L__display_startup307:
	DECFSZ     R13, 1
	GOTO       L__display_startup307
	DECFSZ     R12, 1
	GOTO       L__display_startup307
	NOP
	NOP
;ThrottleMonitor2.mbas,667 :: 		next num
	MOVF       display_startup_num+0, 0
	XORLW      0
	BTFSC      STATUS+0, 2
	GOTO       L__display_startup306
	MOVLW      255
	ADDWF      display_startup_num+0, 1
	GOTO       L__display_startup303
L__display_startup306:
;ThrottleMonitor2.mbas,668 :: 		end sub
L_end_display_startup:
	RETURN
; end of _display_startup

_ad_get:

;ThrottleMonitor2.mbas,673 :: 		sub function ad_get(dim channel as byte) as word
;ThrottleMonitor2.mbas,675 :: 		case CHANNEL_THROTTLE
	MOVF       FARG_ad_get_channel+0, 0
	XORLW      9
	BTFSS      STATUS+0, 2
	GOTO       L__ad_get312
;ThrottleMonitor2.mbas,676 :: 		CHS4_bit = THROTTLE_CHS4
	BCF        CHS4_bit+0, BitPos(CHS4_bit+0)
;ThrottleMonitor2.mbas,677 :: 		CHS3_bit = THROTTLE_CHS3
	BSF        CHS3_bit+0, BitPos(CHS3_bit+0)
;ThrottleMonitor2.mbas,678 :: 		CHS2_bit = THROTTLE_CHS2
	BCF        CHS2_bit+0, BitPos(CHS2_bit+0)
;ThrottleMonitor2.mbas,679 :: 		CHS1_bit = THROTTLE_CHS1
	BCF        CHS1_bit+0, BitPos(CHS1_bit+0)
;ThrottleMonitor2.mbas,680 :: 		CHS0_bit = THROTTLE_CHS0
	BSF        CHS0_bit+0, BitPos(CHS0_bit+0)
	GOTO       L__ad_get309
L__ad_get312:
;ThrottleMonitor2.mbas,681 :: 		case CHANNEL_DIMMER
	MOVF       FARG_ad_get_channel+0, 0
	XORLW      3
	BTFSS      STATUS+0, 2
	GOTO       L__ad_get315
;ThrottleMonitor2.mbas,682 :: 		CHS4_bit = DIMMER_CHS4
	BCF        CHS4_bit+0, BitPos(CHS4_bit+0)
;ThrottleMonitor2.mbas,683 :: 		CHS3_bit = DIMMER_CHS3
	BCF        CHS3_bit+0, BitPos(CHS3_bit+0)
;ThrottleMonitor2.mbas,684 :: 		CHS2_bit = DIMMER_CHS2
	BCF        CHS2_bit+0, BitPos(CHS2_bit+0)
;ThrottleMonitor2.mbas,685 :: 		CHS1_bit = DIMMER_CHS1
	BSF        CHS1_bit+0, BitPos(CHS1_bit+0)
;ThrottleMonitor2.mbas,686 :: 		CHS0_bit = DIMMER_CHS0
	BSF        CHS0_bit+0, BitPos(CHS0_bit+0)
	GOTO       L__ad_get309
L__ad_get315:
;ThrottleMonitor2.mbas,687 :: 		case CHANNEL_FBRAKE
	MOVF       FARG_ad_get_channel+0, 0
	XORLW      1
	BTFSS      STATUS+0, 2
	GOTO       L__ad_get318
;ThrottleMonitor2.mbas,688 :: 		CHS4_bit = FBRAKE_CHS4
	BCF        CHS4_bit+0, BitPos(CHS4_bit+0)
;ThrottleMonitor2.mbas,689 :: 		CHS3_bit = FBRAKE_CHS3
	BCF        CHS3_bit+0, BitPos(CHS3_bit+0)
;ThrottleMonitor2.mbas,690 :: 		CHS2_bit = FBRAKE_CHS2
	BCF        CHS2_bit+0, BitPos(CHS2_bit+0)
;ThrottleMonitor2.mbas,691 :: 		CHS1_bit = FBRAKE_CHS1
	BCF        CHS1_bit+0, BitPos(CHS1_bit+0)
;ThrottleMonitor2.mbas,692 :: 		CHS0_bit = FBRAKE_CHS0
	BSF        CHS0_bit+0, BitPos(CHS0_bit+0)
	GOTO       L__ad_get309
L__ad_get318:
;ThrottleMonitor2.mbas,693 :: 		case CHANNEL_RBRAKE
	MOVF       FARG_ad_get_channel+0, 0
	XORLW      0
	BTFSS      STATUS+0, 2
	GOTO       L__ad_get321
;ThrottleMonitor2.mbas,694 :: 		CHS4_bit = RBRAKE_CHS4
	BCF        CHS4_bit+0, BitPos(CHS4_bit+0)
;ThrottleMonitor2.mbas,695 :: 		CHS3_bit = RBRAKE_CHS3
	BCF        CHS3_bit+0, BitPos(CHS3_bit+0)
;ThrottleMonitor2.mbas,696 :: 		CHS2_bit = RBRAKE_CHS2
	BCF        CHS2_bit+0, BitPos(CHS2_bit+0)
;ThrottleMonitor2.mbas,697 :: 		CHS1_bit = RBRAKE_CHS1
	BCF        CHS1_bit+0, BitPos(CHS1_bit+0)
;ThrottleMonitor2.mbas,698 :: 		CHS0_bit = RBRAKE_CHS0
	BCF        CHS0_bit+0, BitPos(CHS0_bit+0)
	GOTO       L__ad_get309
L__ad_get321:
L__ad_get309:
;ThrottleMonitor2.mbas,701 :: 		GO_NOT_DONE_bit = 1
	BSF        GO_NOT_DONE_bit+0, BitPos(GO_NOT_DONE_bit+0)
;ThrottleMonitor2.mbas,702 :: 		while GO_NOT_DONE_bit = 1
L__ad_get323:
	BTFSC      GO_NOT_DONE_bit+0, BitPos(GO_NOT_DONE_bit+0)
	GOTO       L__ad_get323
;ThrottleMonitor2.mbas,704 :: 		byteH = ADRESH
	MOVF       ADRESH+0, 0
	MOVWF      37
;ThrottleMonitor2.mbas,705 :: 		byteL = ADRESL
	MOVF       ADRESL+0, 0
	MOVWF      36
;ThrottleMonitor2.mbas,706 :: 		result = word_val
	MOVF       36, 0
	MOVWF      R2+0
	MOVF       37, 0
	MOVWF      R2+1
;ThrottleMonitor2.mbas,707 :: 		end sub
	MOVF       R2+0, 0
	MOVWF      R0
	MOVF       R2+1, 0
	MOVWF      R1
L_end_ad_get:
	RETURN
; end of _ad_get

_get_dimmer:

;ThrottleMonitor2.mbas,712 :: 		sub function get_dimmer() as byte
;ThrottleMonitor2.mbas,713 :: 		result = ad_get( CHANNEL_DIMMER ) / 4      ' about 20 to 200
	MOVLW      3
	MOVWF      FARG_ad_get_channel+0
	CALL       _ad_get+0
	MOVF       R0, 0
	MOVWF      R2
	MOVF       R1, 0
	MOVWF      R3
	LSRF       R3, 1
	RRF        R2, 1
	LSRF       R3, 1
	RRF        R2, 1
	MOVF       R2, 0
	MOVWF      get_dimmer_local_result+0
;ThrottleMonitor2.mbas,714 :: 		end sub
	MOVF       get_dimmer_local_result+0, 0
	MOVWF      R0
L_end_get_dimmer:
	RETURN
; end of _get_dimmer

_get_front_brake:

;ThrottleMonitor2.mbas,724 :: 		dim tmp_result as byte
;ThrottleMonitor2.mbas,727 :: 		reverse = true
	MOVLW      255
	MOVWF      get_front_brake_reverse+0
;ThrottleMonitor2.mbas,728 :: 		max_brake = SOFT_AD_FRONT_BARKE
	MOVLW      212
	MOVWF      get_front_brake_max_brake+0
	MOVLW      3
	MOVWF      get_front_brake_max_brake+1
;ThrottleMonitor2.mbas,729 :: 		min_brake = HARD_AD_FRONT_BARKE
	MOVLW      152
	MOVWF      get_front_brake_min_brake+0
	MOVLW      3
	MOVWF      get_front_brake_min_brake+1
;ThrottleMonitor2.mbas,734 :: 		end if
L__get_front_brake331:
;ThrottleMonitor2.mbas,736 :: 		ad_brake_value = ad_get( CHANNEL_FBRAKE )
	MOVLW      1
	MOVWF      FARG_ad_get_channel+0
	CALL       _ad_get+0
	MOVF       R0, 0
	MOVWF      get_front_brake_ad_brake_value+0
	MOVF       R1, 0
	MOVWF      get_front_brake_ad_brake_value+1
;ThrottleMonitor2.mbas,737 :: 		if ad_brake_value < min_brake then
	MOVF       get_front_brake_min_brake+1, 0
	SUBWF      R1, 0
	BTFSS      STATUS+0, 2
	GOTO       L__get_front_brake441
	MOVF       get_front_brake_min_brake+0, 0
	SUBWF      R0, 0
L__get_front_brake441:
	BTFSC      STATUS+0, 0
	GOTO       L__get_front_brake333
;ThrottleMonitor2.mbas,738 :: 		tmp_result = 0
	CLRF       get_front_brake_tmp_result+0
	GOTO       L__get_front_brake334
;ThrottleMonitor2.mbas,739 :: 		else  if max_brake < ad_brake_value then
L__get_front_brake333:
	MOVF       get_front_brake_ad_brake_value+1, 0
	SUBWF      get_front_brake_max_brake+1, 0
	BTFSS      STATUS+0, 2
	GOTO       L__get_front_brake442
	MOVF       get_front_brake_ad_brake_value+0, 0
	SUBWF      get_front_brake_max_brake+0, 0
L__get_front_brake442:
	BTFSC      STATUS+0, 0
	GOTO       L__get_front_brake336
;ThrottleMonitor2.mbas,740 :: 		tmp_result = 8
	MOVLW      8
	MOVWF      get_front_brake_tmp_result+0
	GOTO       L__get_front_brake337
;ThrottleMonitor2.mbas,741 :: 		else
L__get_front_brake336:
;ThrottleMonitor2.mbas,742 :: 		tmp_result = (ad_brake_value - min_brake) / ((max_brake - min_brake) / 8)
	MOVF       get_front_brake_min_brake+0, 0
	SUBWF      get_front_brake_ad_brake_value+0, 0
	MOVWF      R6
	MOVF       get_front_brake_min_brake+1, 0
	SUBWFB     get_front_brake_ad_brake_value+1, 0
	MOVWF      R7
	MOVF       get_front_brake_min_brake+0, 0
	SUBWF      get_front_brake_max_brake+0, 0
	MOVWF      R1
	MOVF       get_front_brake_min_brake+1, 0
	SUBWFB     get_front_brake_max_brake+1, 0
	MOVWF      R2
	MOVF       R1, 0
	MOVWF      R4
	MOVF       R2, 0
	MOVWF      R5
	LSRF       R5, 1
	RRF        R4, 1
	LSRF       R5, 1
	RRF        R4, 1
	LSRF       R5, 1
	RRF        R4, 1
	MOVF       R6, 0
	MOVWF      R0
	MOVF       R7, 0
	MOVWF      R1
	CALL       _Div_16x16_U+0
	MOVF       R0, 0
	MOVWF      get_front_brake_tmp_result+0
;ThrottleMonitor2.mbas,743 :: 		end if
L__get_front_brake337:
;ThrottleMonitor2.mbas,744 :: 		end if
L__get_front_brake334:
;ThrottleMonitor2.mbas,746 :: 		if reverse then
	MOVF       get_front_brake_reverse+0, 0
	BTFSC      STATUS+0, 2
	GOTO       L__get_front_brake339
;ThrottleMonitor2.mbas,747 :: 		result = 8 - tmp_result
	MOVF       get_front_brake_tmp_result+0, 0
	SUBLW      8
	MOVWF      get_front_brake_local_result+0
	GOTO       L__get_front_brake340
;ThrottleMonitor2.mbas,748 :: 		else
L__get_front_brake339:
;ThrottleMonitor2.mbas,749 :: 		result = tmp_result
	MOVF       get_front_brake_tmp_result+0, 0
	MOVWF      get_front_brake_local_result+0
;ThrottleMonitor2.mbas,750 :: 		end if
L__get_front_brake340:
;ThrottleMonitor2.mbas,751 :: 		end sub
	MOVF       get_front_brake_local_result+0, 0
	MOVWF      R0
L_end_get_front_brake:
	RETURN
; end of _get_front_brake

_get_rear_brake:

;ThrottleMonitor2.mbas,761 :: 		dim tmp_result as byte
;ThrottleMonitor2.mbas,767 :: 		else
L__get_rear_brake343:
;ThrottleMonitor2.mbas,768 :: 		reverse = false
	CLRF       get_rear_brake_reverse+0
;ThrottleMonitor2.mbas,769 :: 		max_brake = HARD_AD_REAR_BARKE
	MOVLW      118
	MOVWF      get_rear_brake_max_brake+0
	MOVLW      2
	MOVWF      get_rear_brake_max_brake+1
;ThrottleMonitor2.mbas,770 :: 		min_brake = SOFT_AD_REAR_BARKE
	MOVLW      68
	MOVWF      get_rear_brake_min_brake+0
	MOVLW      2
	MOVWF      get_rear_brake_min_brake+1
;ThrottleMonitor2.mbas,773 :: 		ad_brake_value = ad_get( CHANNEL_RBRAKE )
	CLRF       FARG_ad_get_channel+0
	CALL       _ad_get+0
	MOVF       R0, 0
	MOVWF      get_rear_brake_ad_brake_value+0
	MOVF       R1, 0
	MOVWF      get_rear_brake_ad_brake_value+1
;ThrottleMonitor2.mbas,774 :: 		if ad_brake_value < min_brake then
	MOVF       get_rear_brake_min_brake+1, 0
	SUBWF      R1, 0
	BTFSS      STATUS+0, 2
	GOTO       L__get_rear_brake444
	MOVF       get_rear_brake_min_brake+0, 0
	SUBWF      R0, 0
L__get_rear_brake444:
	BTFSC      STATUS+0, 0
	GOTO       L__get_rear_brake346
;ThrottleMonitor2.mbas,775 :: 		tmp_result = 0
	CLRF       get_rear_brake_tmp_result+0
	GOTO       L__get_rear_brake347
;ThrottleMonitor2.mbas,776 :: 		else if max_brake < ad_brake_value then
L__get_rear_brake346:
	MOVF       get_rear_brake_ad_brake_value+1, 0
	SUBWF      get_rear_brake_max_brake+1, 0
	BTFSS      STATUS+0, 2
	GOTO       L__get_rear_brake445
	MOVF       get_rear_brake_ad_brake_value+0, 0
	SUBWF      get_rear_brake_max_brake+0, 0
L__get_rear_brake445:
	BTFSC      STATUS+0, 0
	GOTO       L__get_rear_brake349
;ThrottleMonitor2.mbas,777 :: 		tmp_result = 8
	MOVLW      8
	MOVWF      get_rear_brake_tmp_result+0
	GOTO       L__get_rear_brake350
;ThrottleMonitor2.mbas,778 :: 		else
L__get_rear_brake349:
;ThrottleMonitor2.mbas,779 :: 		tmp_result = (ad_brake_value - min_brake) / ((max_brake - min_brake) / 8)
	MOVF       get_rear_brake_min_brake+0, 0
	SUBWF      get_rear_brake_ad_brake_value+0, 0
	MOVWF      R6
	MOVF       get_rear_brake_min_brake+1, 0
	SUBWFB     get_rear_brake_ad_brake_value+1, 0
	MOVWF      R7
	MOVF       get_rear_brake_min_brake+0, 0
	SUBWF      get_rear_brake_max_brake+0, 0
	MOVWF      R1
	MOVF       get_rear_brake_min_brake+1, 0
	SUBWFB     get_rear_brake_max_brake+1, 0
	MOVWF      R2
	MOVF       R1, 0
	MOVWF      R4
	MOVF       R2, 0
	MOVWF      R5
	LSRF       R5, 1
	RRF        R4, 1
	LSRF       R5, 1
	RRF        R4, 1
	LSRF       R5, 1
	RRF        R4, 1
	MOVF       R6, 0
	MOVWF      R0
	MOVF       R7, 0
	MOVWF      R1
	CALL       _Div_16x16_U+0
	MOVF       R0, 0
	MOVWF      get_rear_brake_tmp_result+0
;ThrottleMonitor2.mbas,780 :: 		end if
L__get_rear_brake350:
;ThrottleMonitor2.mbas,781 :: 		end if
L__get_rear_brake347:
;ThrottleMonitor2.mbas,783 :: 		if reverse then
	MOVF       get_rear_brake_reverse+0, 0
	BTFSC      STATUS+0, 2
	GOTO       L__get_rear_brake352
;ThrottleMonitor2.mbas,784 :: 		result = 8 - tmp_result
	MOVF       get_rear_brake_tmp_result+0, 0
	SUBLW      8
	MOVWF      get_rear_brake_local_result+0
	GOTO       L__get_rear_brake353
;ThrottleMonitor2.mbas,785 :: 		else
L__get_rear_brake352:
;ThrottleMonitor2.mbas,786 :: 		result = tmp_result
	MOVF       get_rear_brake_tmp_result+0, 0
	MOVWF      get_rear_brake_local_result+0
;ThrottleMonitor2.mbas,787 :: 		end if
L__get_rear_brake353:
;ThrottleMonitor2.mbas,788 :: 		end sub
	MOVF       get_rear_brake_local_result+0, 0
	MOVWF      R0
L_end_get_rear_brake:
	RETURN
; end of _get_rear_brake

_get_throttle:

;ThrottleMonitor2.mbas,794 :: 		dim throttle_value as word
;ThrottleMonitor2.mbas,796 :: 		throttle_value = ad_get( CHANNEL_THROTTLE )
	MOVLW      9
	MOVWF      FARG_ad_get_channel+0
	CALL       _ad_get+0
	MOVF       R0, 0
	MOVWF      get_throttle_throttle_value+0
	MOVF       R1, 0
	MOVWF      get_throttle_throttle_value+1
;ThrottleMonitor2.mbas,797 :: 		if  MIN_AD_THROTTLE < throttle_value then
	MOVF       R1, 0
	SUBLW      0
	BTFSS      STATUS+0, 2
	GOTO       L__get_throttle447
	MOVF       R0, 0
	SUBLW      80
L__get_throttle447:
	BTFSC      STATUS+0, 0
	GOTO       L__get_throttle356
;ThrottleMonitor2.mbas,798 :: 		result = (throttle_value - MIN_AD_THROTTLE) / ((MAX_AD_THROTTLE - MIN_AD_THROTTLE) / 24)
	MOVLW      80
	SUBWF      get_throttle_throttle_value+0, 0
	MOVWF      R3
	MOVLW      0
	SUBWFB     get_throttle_throttle_value+1, 0
	MOVWF      R4
	MOVLW      5
	MOVWF      R2
	MOVF       R3, 0
	MOVWF      R0
	MOVF       R4, 0
	MOVWF      R1
	MOVF       R2, 0
L__get_throttle448:
	BTFSC      STATUS+0, 2
	GOTO       L__get_throttle449
	LSRF       R1, 1
	RRF        R0, 1
	ADDLW      255
	GOTO       L__get_throttle448
L__get_throttle449:
	MOVF       R0, 0
	MOVWF      get_throttle_local_result+0
	GOTO       L__get_throttle357
;ThrottleMonitor2.mbas,799 :: 		else
L__get_throttle356:
;ThrottleMonitor2.mbas,800 :: 		result = 0
	CLRF       get_throttle_local_result+0
;ThrottleMonitor2.mbas,801 :: 		end if
L__get_throttle357:
;ThrottleMonitor2.mbas,802 :: 		end sub
	MOVF       get_throttle_local_result+0, 0
	MOVWF      R0
L_end_get_throttle:
	RETURN
; end of _get_throttle

_main:

;ThrottleMonitor2.mbas,815 :: 		dim target_dac_voltage   as byte
;ThrottleMonitor2.mbas,817 :: 		NOT_WPUEN_bit = 1 ' All weak pull-ups are disabled
	BSF        NOT_WPUEN_bit+0, BitPos(NOT_WPUEN_bit+0)
;ThrottleMonitor2.mbas,819 :: 		THROTTLE_TRIS   = PORT_INPUT
	BSF        TRISB3_bit+0, BitPos(TRISB3_bit+0)
;ThrottleMonitor2.mbas,820 :: 		DIMMER_TRIS     = PORT_INPUT
	BSF        TRISA3_bit+0, BitPos(TRISA3_bit+0)
;ThrottleMonitor2.mbas,821 :: 		FBRAKE_TRIS     = PORT_INPUT
	BSF        TRISA1_bit+0, BitPos(TRISA1_bit+0)
;ThrottleMonitor2.mbas,822 :: 		RBRAKE_TRIS     = PORT_INPUT
	BSF        TRISA0_bit+0, BitPos(TRISA0_bit+0)
;ThrottleMonitor2.mbas,823 :: 		TACHO_TRIS      = PORT_INPUT
	BSF        TRISB0_bit+0, BitPos(TRISB0_bit+0)
;ThrottleMonitor2.mbas,824 :: 		SPEED_TRIS      = PORT_INPUT
	BSF        TRISB2_bit+0, BitPos(TRISB2_bit+0)
;ThrottleMonitor2.mbas,825 :: 		SWITCH_TRIS     = PORT_INPUT
	BSF        TRISB5_bit+0, BitPos(TRISB5_bit+0)
;ThrottleMonitor2.mbas,826 :: 		TURNSIGNAL_TRIS = PORT_INPUT
	BSF        TRISA5_bit+0, BitPos(TRISA5_bit+0)
;ThrottleMonitor2.mbas,828 :: 		I2C1_Init(400000) ' DS1307 I2C is running at 400KHz
	MOVLW      20
	MOVWF      SSP1ADD+0
	CALL       _I2C1_Init+0
;ThrottleMonitor2.mbas,831 :: 		DAC_TRIS    = PORT_OUTPUT
	BCF        TRISA4_bit+0, BitPos(TRISA4_bit+0)
;ThrottleMonitor2.mbas,832 :: 		DACEN_bit   = 1  ' DAC enable
	BSF        DACEN_bit+0, BitPos(DACEN_bit+0)
;ThrottleMonitor2.mbas,833 :: 		DACLPS_bit  = 1  ' DAC Positive reference source selected
	BSF        DACLPS_bit+0, BitPos(DACLPS_bit+0)
;ThrottleMonitor2.mbas,834 :: 		DACOE_bit   = 1  ' DAC output enable
	BSF        DACOE_bit+0, BitPos(DACOE_bit+0)
;ThrottleMonitor2.mbas,835 :: 		DACPSS1_bit = 0  ' VREF+ = VDD
	BCF        DACPSS1_bit+0, BitPos(DACPSS1_bit+0)
;ThrottleMonitor2.mbas,836 :: 		DACPSS0_bit = 0  ' VREF+ = VDD
	BCF        DACPSS0_bit+0, BitPos(DACPSS0_bit+0)
;ThrottleMonitor2.mbas,837 :: 		DACNSS_bit  = 0  ' VREF- = VSS
	BCF        DACNSS_bit+0, BitPos(DACNSS_bit+0)
;ThrottleMonitor2.mbas,839 :: 		dac_voltage = MAX_DAC_VOLTAGE
	MOVLW      31
	MOVWF      main_dac_voltage+0
;ThrottleMonitor2.mbas,840 :: 		DACCON1 = dac_voltage
	MOVLW      31
	MOVWF      DACCON1+0
;ThrottleMonitor2.mbas,843 :: 		THROTTLE_ANALOG_PORT = ANALOG_INPUT
	BSF        ANSB3_bit+0, BitPos(ANSB3_bit+0)
;ThrottleMonitor2.mbas,844 :: 		DIMMER_ANALOG_PORT   = ANALOG_INPUT
	BSF        ANSA3_bit+0, BitPos(ANSA3_bit+0)
;ThrottleMonitor2.mbas,845 :: 		FBRAKE_ANALOG_PORT   = ANALOG_INPUT
	BSF        ANSA1_bit+0, BitPos(ANSA1_bit+0)
;ThrottleMonitor2.mbas,846 :: 		RBRAKE_ANALOG_PORT   = ANALOG_INPUT
	BSF        ANSA0_bit+0, BitPos(ANSA0_bit+0)
;ThrottleMonitor2.mbas,848 :: 		ADON_bit    = 1 ' A/D enable
	BSF        ADON_bit+0, BitPos(ADON_bit+0)
;ThrottleMonitor2.mbas,849 :: 		ADFM_bit    = 1 ' Right justified
	BSF        ADFM_bit+0, BitPos(ADFM_bit+0)
;ThrottleMonitor2.mbas,850 :: 		ADCS2_bit   = 1 ' A/D Conversion Clock
	BSF        ADCS2_bit+0, BitPos(ADCS2_bit+0)
;ThrottleMonitor2.mbas,851 :: 		ADCS1_bit   = 1
	BSF        ADCS1_bit+0, BitPos(ADCS1_bit+0)
;ThrottleMonitor2.mbas,852 :: 		ADCS0_bit   = 1
	BSF        ADCS0_bit+0, BitPos(ADCS0_bit+0)
;ThrottleMonitor2.mbas,853 :: 		ADNREF_bit  = 0 ' VREF- is connected to VSS
	BCF        ADNREF_bit+0, BitPos(ADNREF_bit+0)
;ThrottleMonitor2.mbas,854 :: 		ADPREF1_bit = 0 ' VREF+ is connected to VDD
	BCF        ADPREF1_bit+0, BitPos(ADPREF1_bit+0)
;ThrottleMonitor2.mbas,855 :: 		ADPREF0_bit = 0
	BCF        ADPREF0_bit+0, BitPos(ADPREF0_bit+0)
;ThrottleMonitor2.mbas,858 :: 		T2OUTPS3_bit = 0    ' 1:1 Postscaler
	BCF        T2OUTPS3_bit+0, BitPos(T2OUTPS3_bit+0)
;ThrottleMonitor2.mbas,859 :: 		T2OUTPS2_bit = 0
	BCF        T2OUTPS2_bit+0, BitPos(T2OUTPS2_bit+0)
;ThrottleMonitor2.mbas,860 :: 		T2OUTPS1_bit = 0
	BCF        T2OUTPS1_bit+0, BitPos(T2OUTPS1_bit+0)
;ThrottleMonitor2.mbas,861 :: 		T2OUTPS0_bit = 0
	BCF        T2OUTPS0_bit+0, BitPos(T2OUTPS0_bit+0)
;ThrottleMonitor2.mbas,862 :: 		TMR2ON_bit   = 1
	BSF        TMR2ON_bit+0, BitPos(TMR2ON_bit+0)
;ThrottleMonitor2.mbas,863 :: 		T2CKPS1_bit  = 1    ' Prescaler is 64
	BSF        T2CKPS1_bit+0, BitPos(T2CKPS1_bit+0)
;ThrottleMonitor2.mbas,864 :: 		T2CKPS0_bit  = 1
	BSF        T2CKPS0_bit+0, BitPos(T2CKPS0_bit+0)
;ThrottleMonitor2.mbas,865 :: 		PR2 = 124           ' 1[msec] period
	MOVLW      124
	MOVWF      PR2+0
;ThrottleMonitor2.mbas,866 :: 		TMR2IE_bit = 1
	BSF        TMR2IE_bit+0, BitPos(TMR2IE_bit+0)
;ThrottleMonitor2.mbas,869 :: 		T4OUTPS3_bit = 0
	BCF        T4OUTPS3_bit+0, BitPos(T4OUTPS3_bit+0)
;ThrottleMonitor2.mbas,870 :: 		T4OUTPS2_bit = 0
	BCF        T4OUTPS2_bit+0, BitPos(T4OUTPS2_bit+0)
;ThrottleMonitor2.mbas,871 :: 		T4OUTPS1_bit = 0
	BCF        T4OUTPS1_bit+0, BitPos(T4OUTPS1_bit+0)
;ThrottleMonitor2.mbas,872 :: 		T4OUTPS0_bit = 0
	BCF        T4OUTPS0_bit+0, BitPos(T4OUTPS0_bit+0)
;ThrottleMonitor2.mbas,873 :: 		TMR4ON_bit   = 1
	BSF        TMR4ON_bit+0, BitPos(TMR4ON_bit+0)
;ThrottleMonitor2.mbas,874 :: 		T4CKPS1_bit  = 0
	BCF        T4CKPS1_bit+0, BitPos(T4CKPS1_bit+0)
;ThrottleMonitor2.mbas,875 :: 		T4CKPS0_bit  = 0
	BCF        T4CKPS0_bit+0, BitPos(T4CKPS0_bit+0)
;ThrottleMonitor2.mbas,876 :: 		PR4 = 255
	MOVLW      255
	MOVWF      PR4+0
;ThrottleMonitor2.mbas,877 :: 		TMR4IE_bit = 1
	BSF        TMR4IE_bit+0, BitPos(TMR4IE_bit+0)
;ThrottleMonitor2.mbas,880 :: 		T6OUTPS3_bit = 0
	BCF        T6OUTPS3_bit+0, BitPos(T6OUTPS3_bit+0)
;ThrottleMonitor2.mbas,881 :: 		T6OUTPS2_bit = 0
	BCF        T6OUTPS2_bit+0, BitPos(T6OUTPS2_bit+0)
;ThrottleMonitor2.mbas,882 :: 		T6OUTPS1_bit = 0
	BCF        T6OUTPS1_bit+0, BitPos(T6OUTPS1_bit+0)
;ThrottleMonitor2.mbas,883 :: 		T6OUTPS0_bit = 0
	BCF        T6OUTPS0_bit+0, BitPos(T6OUTPS0_bit+0)
;ThrottleMonitor2.mbas,884 :: 		TMR6ON_bit   = 1
	BSF        TMR6ON_bit+0, BitPos(TMR6ON_bit+0)
;ThrottleMonitor2.mbas,885 :: 		T6CKPS1_bit  = 0
	BCF        T6CKPS1_bit+0, BitPos(T6CKPS1_bit+0)
;ThrottleMonitor2.mbas,886 :: 		T6CKPS0_bit  = 0
	BCF        T6CKPS0_bit+0, BitPos(T6CKPS0_bit+0)
;ThrottleMonitor2.mbas,887 :: 		PR6 = 255
	MOVLW      255
	MOVWF      PR6+0
;ThrottleMonitor2.mbas,888 :: 		TMR6IE_bit = 1
	BSF        TMR6IE_bit+0, BitPos(TMR6IE_bit+0)
;ThrottleMonitor2.mbas,891 :: 		INTEDG_bit = 1 ' Interrupt on rising edge of INT pin
	BSF        INTEDG_bit+0, BitPos(INTEDG_bit+0)
;ThrottleMonitor2.mbas,892 :: 		TACHO_SIGNAL_INTERRUPT_ENABLE    = 1 ' Enables the INT external interrupt
	BSF        INTE_bit+0, BitPos(INTE_bit+0)
;ThrottleMonitor2.mbas,893 :: 		TACHO_SIGNAL_INTERRUPT_OCCURRED  = 0 ' Clear interupt flag
	BCF        INTF_bit+0, BitPos(INTF_bit+0)
;ThrottleMonitor2.mbas,896 :: 		SPEED_SIGNAL_INTERRUPT_ENABLE    = 1 ' Enables the interrupt-on-change
	BSF        IOCIE_bit+0, BitPos(IOCIE_bit+0)
;ThrottleMonitor2.mbas,897 :: 		SPEED_SIGNAL_INTERRUPT_OCCURRED  = 0 ' Clear interupt flag
	BCF        IOCBF2_bit+0, BitPos(IOCBF2_bit+0)
;ThrottleMonitor2.mbas,898 :: 		ANSB2_bit = 0 ' Digital I/O
	BCF        ANSB2_bit+0, BitPos(ANSB2_bit+0)
;ThrottleMonitor2.mbas,899 :: 		IOCBP2_bit = 0 ' port RB2 rising edge
	BCF        IOCBP2_bit+0, BitPos(IOCBP2_bit+0)
;ThrottleMonitor2.mbas,900 :: 		IOCBN2_bit = 1 ' port RB2 falling edge
	BSF        IOCBN2_bit+0, BitPos(IOCBN2_bit+0)
;ThrottleMonitor2.mbas,902 :: 		delay_ms(100)
	MOVLW      5
	MOVWF      R11
	MOVLW      15
	MOVWF      R12
	MOVLW      241
	MOVWF      R13
L__main359:
	DECFSZ     R13, 1
	GOTO       L__main359
	DECFSZ     R12, 1
	GOTO       L__main359
	DECFSZ     R11, 1
	GOTO       L__main359
;ThrottleMonitor2.mbas,904 :: 		ioexpander_tca9535_initialize()
	CALL       _ioexpander_tca9535_initialize+0
;ThrottleMonitor2.mbas,906 :: 		throttle_value_prev = 0
	CLRF       main_throttle_value_prev+0
;ThrottleMonitor2.mbas,908 :: 		display_startup()
	CALL       _display_startup+0
;ThrottleMonitor2.mbas,910 :: 		speed_tmr_timeout = false
	CLRF       _speed_tmr_timeout+0
;ThrottleMonitor2.mbas,911 :: 		speed_tmr_overflow_count = 0
	CLRF       _speed_tmr_overflow_count+0
	CLRF       _speed_tmr_overflow_count+1
;ThrottleMonitor2.mbas,912 :: 		speed_measure_status = MEASUREMENT_SET
	CLRF       _speed_measure_status+0
;ThrottleMonitor2.mbas,913 :: 		speed_display_update_counter = 0
	CLRF       _speed_display_update_counter+0
	CLRF       _speed_display_update_counter+1
;ThrottleMonitor2.mbas,914 :: 		dimmer_update_counter = 0
	CLRF       _dimmer_update_counter+0
;ThrottleMonitor2.mbas,917 :: 		PEIE_bit = 1 ' Enables all active peripheral interrupts
	BSF        PEIE_bit+0, BitPos(PEIE_bit+0)
;ThrottleMonitor2.mbas,918 :: 		GIE_bit = 1 ' Enables all active interrupts
	BSF        GIE_bit+0, BitPos(GIE_bit+0)
;ThrottleMonitor2.mbas,920 :: 		speed_kph = 0
	CLRF       main_speed_kph+0
;ThrottleMonitor2.mbas,921 :: 		display_speed( 0 )
	CLRF       FARG_display_speed_number+0
	CALL       _display_speed+0
;ThrottleMonitor2.mbas,922 :: 		display_gear_position( 0, 0 )
	CLRF       FARG_display_gear_position_rpm+0
	CLRF       FARG_display_gear_position_rpm+1
	CLRF       FARG_display_gear_position_rpm+2
	CLRF       FARG_display_gear_position_rpm+3
	CLRF       FARG_display_gear_position_speed_kph+0
	CALL       _display_gear_position+0
;ThrottleMonitor2.mbas,924 :: 		while(true)
L__main361:
;ThrottleMonitor2.mbas,926 :: 		if speed_measure_status = MEASUREMENT_DONE then
	MOVF       _speed_measure_status+0, 0
	XORLW      2
	BTFSS      STATUS+0, 2
	GOTO       L__main366
;ThrottleMonitor2.mbas,927 :: 		speed_mm_per_minutes = (((TMR_COUNT_PER_MINUTES * SPEED_PULSE_COUNT) / ((speed_tmr_overflow_save * 255) + speed_tmr_save)) * TIRE_CIRCUMFERENCE_SHMODE) / SPEED_PULSE_PER_ROTATION
	MOVF       _speed_tmr_overflow_save+0, 0
	MOVWF      R0
	MOVF       _speed_tmr_overflow_save+1, 0
	MOVWF      R1
	MOVF       _speed_tmr_overflow_save+2, 0
	MOVWF      R2
	MOVF       _speed_tmr_overflow_save+3, 0
	MOVWF      R3
	MOVLW      255
	MOVWF      R4
	CLRF       R5
	CLRF       R6
	CLRF       R7
	CALL       _Mul_32x32_U+0
	MOVF       _speed_tmr_save+0, 0
	ADDWF      R0, 0
	MOVWF      R4
	MOVLW      0
	ADDWFC     R1, 0
	MOVWF      R5
	MOVLW      0
	ADDWFC     R2, 0
	MOVWF      R6
	MOVLW      0
	ADDWFC     R3, 0
	MOVWF      R7
	MOVLW      0
	MOVWF      R0
	MOVLW      24
	MOVWF      R1
	MOVLW      13
	MOVWF      R2
	MOVLW      143
	MOVWF      R3
	CALL       _Div_32x32_U+0
	MOVLW      123
	MOVWF      R4
	MOVLW      6
	MOVWF      R5
	CLRF       R6
	CLRF       R7
	CALL       _Mul_32x32_U+0
	MOVLW      47
	MOVWF      R4
	CLRF       R5
	CLRF       R6
	CLRF       R7
	CALL       _Div_32x32_U+0
;ThrottleMonitor2.mbas,928 :: 		speed_kph = (speed_mm_per_minutes * 60) / 1000000
	MOVLW      60
	MOVWF      R4
	CLRF       R5
	CLRF       R6
	CLRF       R7
	CALL       _Mul_32x32_U+0
	MOVLW      64
	MOVWF      R4
	MOVLW      66
	MOVWF      R5
	MOVLW      15
	MOVWF      R6
	MOVLW      0
	MOVWF      R7
	CALL       _Div_32x32_U+0
	MOVF       R0, 0
	MOVWF      main_speed_kph+0
;ThrottleMonitor2.mbas,929 :: 		speed_measure_status = MEASUREMENT_SET
	CLRF       _speed_measure_status+0
L__main366:
;ThrottleMonitor2.mbas,931 :: 		if speed_tmr_timeout = true then
	MOVF       _speed_tmr_timeout+0, 0
	XORLW      255
	BTFSS      STATUS+0, 2
	GOTO       L__main369
;ThrottleMonitor2.mbas,932 :: 		speed_kph = 0
	CLRF       main_speed_kph+0
L__main369:
;ThrottleMonitor2.mbas,934 :: 		if speed_display_update_counter = 300 then ' 300[msec]
	MOVF       _speed_display_update_counter+1, 0
	XORLW      1
	BTFSS      STATUS+0, 2
	GOTO       L__main451
	MOVLW      44
	XORWF      _speed_display_update_counter+0, 0
L__main451:
	BTFSS      STATUS+0, 2
	GOTO       L__main372
;ThrottleMonitor2.mbas,935 :: 		display_speed( speed_kph )
	MOVF       main_speed_kph+0, 0
	MOVWF      FARG_display_speed_number+0
	CALL       _display_speed+0
;ThrottleMonitor2.mbas,936 :: 		speed_display_update_counter = 0
	CLRF       _speed_display_update_counter+0
	CLRF       _speed_display_update_counter+1
L__main372:
;ThrottleMonitor2.mbas,949 :: 		if tacho_measure_status = MEASUREMENT_DONE then
	MOVF       _tacho_measure_status+0, 0
	XORLW      2
	BTFSS      STATUS+0, 2
	GOTO       L__main375
;ThrottleMonitor2.mbas,950 :: 		rpm = (TMR_COUNT_PER_MINUTES * TACHO_PULSE_COUNT) / ((tacho_tmr_overflow_save * 255) + tacho_tmr_save)
	MOVF       _tacho_tmr_overflow_save+0, 0
	MOVWF      R0
	MOVF       _tacho_tmr_overflow_save+1, 0
	MOVWF      R1
	MOVF       _tacho_tmr_overflow_save+2, 0
	MOVWF      R2
	MOVF       _tacho_tmr_overflow_save+3, 0
	MOVWF      R3
	MOVLW      255
	MOVWF      R4
	CLRF       R5
	CLRF       R6
	CLRF       R7
	CALL       _Mul_32x32_U+0
	MOVF       _tacho_tmr_save+0, 0
	ADDWF      R0, 0
	MOVWF      R4
	MOVLW      0
	ADDWFC     R1, 0
	MOVWF      R5
	MOVLW      0
	ADDWFC     R2, 0
	MOVWF      R6
	MOVLW      0
	ADDWFC     R3, 0
	MOVWF      R7
	MOVLW      0
	MOVWF      R0
	MOVLW      56
	MOVWF      R1
	MOVLW      156
	MOVWF      R2
	MOVLW      28
	MOVWF      R3
	CALL       _Div_32x32_U+0
	MOVF       R0, 0
	MOVWF      main_rpm+0
	MOVF       R1, 0
	MOVWF      main_rpm+1
	MOVF       R2, 0
	MOVWF      main_rpm+2
	MOVF       R3, 0
	MOVWF      main_rpm+3
;ThrottleMonitor2.mbas,951 :: 		if TURNSIGNAL_PORT = 0 then
	BTFSC      RA5_bit+0, BitPos(RA5_bit+0)
	GOTO       L__main378
;ThrottleMonitor2.mbas,952 :: 		display_rpm( ( rpm * 40 * 2 ) / MAX_RPM )
	MOVF       main_rpm+0, 0
	MOVWF      R0
	MOVF       main_rpm+1, 0
	MOVWF      R1
	MOVF       main_rpm+2, 0
	MOVWF      R2
	MOVF       main_rpm+3, 0
	MOVWF      R3
	MOVLW      40
	MOVWF      R4
	CLRF       R5
	CLRF       R6
	CLRF       R7
	CALL       _Mul_32x32_U+0
	MOVF       R0, 0
	MOVWF      R4
	MOVF       R1, 0
	MOVWF      R5
	MOVF       R2, 0
	MOVWF      R6
	MOVF       R3, 0
	MOVWF      R7
	LSLF       R4, 1
	RLF        R5, 1
	RLF        R6, 1
	RLF        R7, 1
	MOVF       R4, 0
	MOVWF      R0
	MOVF       R5, 0
	MOVWF      R1
	MOVF       R6, 0
	MOVWF      R2
	MOVF       R7, 0
	MOVWF      R3
	MOVLW      16
	MOVWF      R4
	MOVLW      39
	MOVWF      R5
	CLRF       R6
	CLRF       R7
	CALL       _Div_32x32_U+0
	MOVF       R0, 0
	MOVWF      FARG_display_rpm_rpm+0
	CALL       _display_rpm+0
	GOTO       L__main379
;ThrottleMonitor2.mbas,953 :: 		else
L__main378:
;ThrottleMonitor2.mbas,954 :: 		display_rpm_reverse( ( rpm * 40 * 2 )/ MAX_RPM )
	MOVF       main_rpm+0, 0
	MOVWF      R0
	MOVF       main_rpm+1, 0
	MOVWF      R1
	MOVF       main_rpm+2, 0
	MOVWF      R2
	MOVF       main_rpm+3, 0
	MOVWF      R3
	MOVLW      40
	MOVWF      R4
	CLRF       R5
	CLRF       R6
	CLRF       R7
	CALL       _Mul_32x32_U+0
	MOVF       R0, 0
	MOVWF      R4
	MOVF       R1, 0
	MOVWF      R5
	MOVF       R2, 0
	MOVWF      R6
	MOVF       R3, 0
	MOVWF      R7
	LSLF       R4, 1
	RLF        R5, 1
	RLF        R6, 1
	RLF        R7, 1
	MOVF       R4, 0
	MOVWF      R0
	MOVF       R5, 0
	MOVWF      R1
	MOVF       R6, 0
	MOVWF      R2
	MOVF       R7, 0
	MOVWF      R3
	MOVLW      16
	MOVWF      R4
	MOVLW      39
	MOVWF      R5
	CLRF       R6
	CLRF       R7
	CALL       _Div_32x32_U+0
	MOVF       R0, 0
	MOVWF      FARG_display_rpm_reverse_rpm+0
	CALL       _display_rpm_reverse+0
;ThrottleMonitor2.mbas,955 :: 		end if
L__main379:
;ThrottleMonitor2.mbas,956 :: 		tacho_measure_status = MEASUREMENT_SET
	CLRF       _tacho_measure_status+0
L__main375:
;ThrottleMonitor2.mbas,958 :: 		if tacho_tmr_timeout = true then
	MOVF       _tacho_tmr_timeout+0, 0
	XORLW      255
	BTFSS      STATUS+0, 2
	GOTO       L__main381
;ThrottleMonitor2.mbas,959 :: 		if TURNSIGNAL_PORT = 0 then
	BTFSC      RA5_bit+0, BitPos(RA5_bit+0)
	GOTO       L__main384
;ThrottleMonitor2.mbas,960 :: 		display_rpm( 0 )
	CLRF       FARG_display_rpm_rpm+0
	CALL       _display_rpm+0
	GOTO       L__main385
;ThrottleMonitor2.mbas,961 :: 		else
L__main384:
;ThrottleMonitor2.mbas,962 :: 		display_rpm( 40 )
	MOVLW      40
	MOVWF      FARG_display_rpm_rpm+0
	CALL       _display_rpm+0
;ThrottleMonitor2.mbas,963 :: 		end if
L__main385:
;ThrottleMonitor2.mbas,964 :: 		tacho_measure_status = MEASUREMENT_SET
	CLRF       _tacho_measure_status+0
L__main381:
;ThrottleMonitor2.mbas,968 :: 		display_gear_position( rpm * 2, speed_kph )
	MOVF       main_rpm+0, 0
	MOVWF      FARG_display_gear_position_rpm+0
	MOVF       main_rpm+1, 0
	MOVWF      FARG_display_gear_position_rpm+1
	MOVF       main_rpm+2, 0
	MOVWF      FARG_display_gear_position_rpm+2
	MOVF       main_rpm+3, 0
	MOVWF      FARG_display_gear_position_rpm+3
	LSLF       FARG_display_gear_position_rpm+0, 1
	RLF        FARG_display_gear_position_rpm+1, 1
	RLF        FARG_display_gear_position_rpm+2, 1
	RLF        FARG_display_gear_position_rpm+3, 1
	MOVF       main_speed_kph+0, 0
	MOVWF      FARG_display_gear_position_speed_kph+0
	CALL       _display_gear_position+0
;ThrottleMonitor2.mbas,971 :: 		display_front_brake( get_front_brake() )
	CALL       _get_front_brake+0
	MOVF       R0, 0
	MOVWF      FARG_display_front_brake_position+0
	CALL       _display_front_brake+0
;ThrottleMonitor2.mbas,974 :: 		display_rear_brake( get_rear_brake() )
	CALL       _get_rear_brake+0
	MOVF       R0, 0
	MOVWF      FARG_display_rear_brake_position+0
	CALL       _display_rear_brake+0
;ThrottleMonitor2.mbas,977 :: 		throttle_value = get_throttle()
	CALL       _get_throttle+0
	MOVF       R0, 0
	MOVWF      main_throttle_value+0
;ThrottleMonitor2.mbas,978 :: 		if throttle_value_prev < throttle_value then
	MOVF       R0, 0
	SUBWF      main_throttle_value_prev+0, 0
	BTFSC      STATUS+0, 0
	GOTO       L__main387
;ThrottleMonitor2.mbas,979 :: 		if ( throttle_value - throttle_value_prev ) < THROTTLE_ERROR then
	MOVF       main_throttle_value_prev+0, 0
	SUBWF      main_throttle_value+0, 0
	MOVWF      R1
	MOVLW      2
	SUBWF      R1, 0
	BTFSC      STATUS+0, 0
	GOTO       L__main390
;ThrottleMonitor2.mbas,980 :: 		display_throttle( throttle_value )
	MOVF       main_throttle_value+0, 0
	MOVWF      FARG_display_throttle_throttle_position+0
	CALL       _display_throttle+0
L__main390:
;ThrottleMonitor2.mbas,981 :: 		end if
	GOTO       L__main388
;ThrottleMonitor2.mbas,982 :: 		else
L__main387:
;ThrottleMonitor2.mbas,983 :: 		if ( throttle_value_prev - throttle_value ) < THROTTLE_ERROR then
	MOVF       main_throttle_value+0, 0
	SUBWF      main_throttle_value_prev+0, 0
	MOVWF      R1
	MOVLW      2
	SUBWF      R1, 0
	BTFSC      STATUS+0, 0
	GOTO       L__main393
;ThrottleMonitor2.mbas,984 :: 		display_throttle( throttle_value )
	MOVF       main_throttle_value+0, 0
	MOVWF      FARG_display_throttle_throttle_position+0
	CALL       _display_throttle+0
L__main393:
;ThrottleMonitor2.mbas,986 :: 		end if
L__main388:
;ThrottleMonitor2.mbas,987 :: 		throttle_value_prev = throttle_value
	MOVF       main_throttle_value+0, 0
	MOVWF      main_throttle_value_prev+0
;ThrottleMonitor2.mbas,990 :: 		if dimmer_update_counter = 100 then
	MOVF       _dimmer_update_counter+0, 0
	XORLW      100
	BTFSS      STATUS+0, 2
	GOTO       L__main396
;ThrottleMonitor2.mbas,991 :: 		brightness = get_dimmer()
	CALL       _get_dimmer+0
	MOVF       R0, 0
	MOVWF      main_brightness+0
;ThrottleMonitor2.mbas,992 :: 		if brightness < MIN_BRIGHTNESS then
	MOVLW      20
	SUBWF      R0, 0
	BTFSC      STATUS+0, 0
	GOTO       L__main399
;ThrottleMonitor2.mbas,993 :: 		brightness = MIN_BRIGHTNESS
	MOVLW      20
	MOVWF      main_brightness+0
L__main399:
;ThrottleMonitor2.mbas,995 :: 		target_dac_voltage = MIN_DAC_VOLTAGE + ( brightness - MIN_BRIGHTNESS) / (( MAX_BRIGHTNESS - MIN_BRIGHTNESS) / (MAX_DAC_VOLTAGE - MIN_DAC_VOLTAGE))
	MOVLW      20
	SUBWF      main_brightness+0, 0
	MOVWF      R0
	MOVLW      19
	MOVWF      R4
	CALL       _Div_8x8_U+0
	MOVF       R0, 0
	ADDLW      21
	MOVWF      R1
	MOVF       R1, 0
	MOVWF      main_target_dac_voltage+0
;ThrottleMonitor2.mbas,997 :: 		if MAX_DAC_VOLTAGE < target_dac_voltage then
	MOVF       R1, 0
	SUBLW      31
	BTFSC      STATUS+0, 0
	GOTO       L__main402
;ThrottleMonitor2.mbas,998 :: 		target_dac_voltage = MAX_DAC_VOLTAGE
	MOVLW      31
	MOVWF      main_target_dac_voltage+0
L__main402:
;ThrottleMonitor2.mbas,1000 :: 		if dac_voltage < target_dac_voltage then
	MOVF       main_target_dac_voltage+0, 0
	SUBWF      main_dac_voltage+0, 0
	BTFSC      STATUS+0, 0
	GOTO       L__main405
;ThrottleMonitor2.mbas,1001 :: 		dac_voltage = dac_voltage + 1
	INCF       main_dac_voltage+0, 1
L__main405:
;ThrottleMonitor2.mbas,1003 :: 		if dac_voltage > target_dac_voltage then
	MOVF       main_dac_voltage+0, 0
	SUBWF      main_target_dac_voltage+0, 0
	BTFSC      STATUS+0, 0
	GOTO       L__main408
;ThrottleMonitor2.mbas,1004 :: 		dac_voltage = dac_voltage - 1
	DECF       main_dac_voltage+0, 1
L__main408:
;ThrottleMonitor2.mbas,1006 :: 		DACCON1 = dac_voltage
	MOVF       main_dac_voltage+0, 0
	MOVWF      DACCON1+0
;ThrottleMonitor2.mbas,1007 :: 		dimmer_update_counter = 0
	CLRF       _dimmer_update_counter+0
L__main396:
;ThrottleMonitor2.mbas,1009 :: 		wend
	GOTO       L__main361
L_end_main:
	GOTO       $+0
; end of _main
